<?xml version='1.0' encoding='ISO-8859-1'?>

<!-- ============================================================ -->
<!--                                                              -->
<!-- READ THIS FIRST:                                             -->
<!--                                                              -->
<!-- Experience has shown that altering this file in any way can  -->
<!-- produce unanticipated results in the PDF output, not only    -->
<!-- in the area where change was intended, but in unexpected and -->
<!-- diverse additional areas. Our source files are so diverse    -->
<!-- in structure and content that it is NEVER a good idea to     -->
<!-- start work on this stylesheet with the idea of significantly -->
<!-- improving the look and feel of a specific book. Nor is it a  -->
<!-- good idea to test changes in one "representative" book and   -->
<!-- then consider the job done. The changes that strongly        -->
<!-- improve one book, or one style of book, are just as likely   -->
<!-- to destroy some other book in a way that is not predictable  -->
<!-- in advance of doing the work. If you work on this file,      -->
<!-- please anticipate that you will experience effects such as   -->
<!-- these, and please take steps to assess their full impact.    -->
<!-- Thousands of pages of PDF output are posted on our website   -->
<!-- and writers have grown accustomed to having these pages      -->
<!-- generated trouble-free, automatically, without any           -->
<!-- proofreading required once the content is stable.  So...     --> 
<!--                                                              -->
<!-- FIRST, DO NO HARM.                                           -->
<!--                                                              -->
<!-- Do not work on this file unless your work estimate includes  -->
<!-- sufficient time to view the following PDF output files, page -->
<!-- by page. (Yes, this means use the PageDown button from first -->
<!-- to last; it works!) This minimum test set employs virtually  -->
<!-- every DocBook element that our DTD permits. It also includes -->
<!-- a wide enough variety of writer styles and document types to -->
<!-- catch most side effects so you can address them before they  -->
<!-- impact anyone else: RCOS,GCSP,RGOT,ACSP,AZSS,ARAPI,GSP,EBPL, -->
<!-- EGDV,AUGS,ASEC,GCJB,RCSP,GSEC.                               -->
<!--                                                              -->
<!-- To verify major reconstructive changes, or to get a wider    -->
<!-- sampling of writer and subject-matter styles that do not     -->
<!-- overlap with the files listed above, also test: RERR,GCOS,   -->
<!-- GSA,GIOD,GAX,GBAS,IISG,ACTERM,ADDP,GCPP,RSQL.                --> 
<!--                                                              -->
<!-- The two sets of test files listed above provide a            -->
<!-- statistically significant portion of the thousands           -->
<!-- of output pages that are routinely generated by this file.   -->
<!--                                                              -->
<!-- GET CONSENSUS.                                               -->
<!--                                                              -->
<!-- As a final step in testing any change, bring                 -->
<!-- printed PDF output to the team for review and signoff.       -->
<!--                                                              -->
<!-- This stylesheet renders XML documentation to PDF via XEP.    -->
<!-- It supports only those DocBook XML elements required to      -->
<!-- produce InterSystems product documentation.                  -->
<!--                                                              -->
<!--     Author: Susan Korgen                                     -->
<!--      2003-2005 InterSystems Corporation                     -->
<!--                                                              -->
<!-- This InterSystems stylesheet was created through incremental -->
<!-- editing and testing of a sample XSL file provided by the     -->
<!-- makers of the XEP tool. Although this process replaced the   -->
<!-- original file over time, we acknowledge this source:         -->
<!--                                                              -->
<!--     Author: Nikolai Grigoriev                                -->
<!--      RenderX, 2000-2003                                     -->
<!--                                                              -->
<!-- ============================================================ -->

<!DOCTYPE xsl:stylesheet
          [
          <!ENTITY % winansi SYSTEM "winansi.entities">
          %winansi;
          ]>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format"
                xmlns:rx="http://www.renderx.com/XSL/Extensions">
   <xsl:import href="index_xep.xsl"/>
   <xsl:output method="xml"
               version="1.0"
               indent="no"
               encoding="ISO-8859-1"/>
   <xsl:param name="callout.dingbats"
              select="'true'"/>

   <!-- =============================================================== -->
   <!-- Parameters                                                      -->
   <!-- =============================================================== -->

   <xsl:param name="title-color">#0060A0</xsl:param>

   <xsl:param name="href-color">#0040C0</xsl:param>

   <xsl:param name="opus">
      <xsl:value-of select="book/title"/>
   </xsl:param>

   <xsl:param name="bookid">
      <xsl:value-of select="book/bookinfo/pubsnumber"/>
   </xsl:param>

   <xsl:param name="bookproduct">
      <xsl:value-of select="book/bookinfo/productname"/>
   </xsl:param>

   <xsl:param name="bookrelease">
      <xsl:value-of select="book/bookinfo/releaseinfo"/>
   </xsl:param>

   <xsl:param name="bookdate">
      <xsl:value-of select="book/bookinfo/date"/>
   </xsl:param>

   <xsl:param name="bookissue">
      <xsl:value-of select="book/bookinfo/edition"/>
   </xsl:param>

   <xsl:param name="junior">
      <xsl:value-of select="article/title"/>
   </xsl:param>

   <xsl:param name="articleid">
      <xsl:value-of select="article/artheader/pubsnumber"/>
   </xsl:param>

   <xsl:param name="articleproduct">
      <xsl:value-of select="article/artheader/productname"/>
   </xsl:param>

   <xsl:param name="articlerelease">
      <xsl:value-of select="article/artheader/releaseinfo"/>
   </xsl:param>

   <xsl:param name="articledate">
      <xsl:value-of select="article/artheader/date"/>
   </xsl:param>

   <xsl:param name="articleissue">
      <xsl:value-of select="article/artheader/edition"/>
   </xsl:param>

   <!-- =============================================================== -->
   <!-- Attribute sets: Page dimensions                                 -->
   <!-- =============================================================== -->

   <xsl:attribute-set name="page-dimensions">
      <xsl:attribute name="page-height"> 9in </xsl:attribute>
      <xsl:attribute name="page-width"> 7in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="cover-page-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-left"> 1.1in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.7in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="blank-page-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-left"> 1.0in </xsl:attribute>
      <xsl:attribute name="margin-right"> 1.0in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="bare-page-left-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.9in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="bare-page-right-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.9in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.5in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="first-page-right-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.9in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.5in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="contents-page-left-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 1.0in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.9in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="contents-page-right-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 1.0in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.9in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.5in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="regular-page-left-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.9in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="regular-page-right-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.9in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.5in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="index-page-left-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.8in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.5in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.9in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="index-page-right-margins">
      <xsl:attribute name="margin-top"> 0.6in </xsl:attribute>
      <xsl:attribute name="margin-bottom"> 0.8in </xsl:attribute>
      <xsl:attribute name="margin-left"> 0.9in </xsl:attribute>
      <xsl:attribute name="margin-right"> 0.5in </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="legal-page-hdr-para">
      <xsl:attribute name="font-size"> 8pt </xsl:attribute>
      <xsl:attribute name="font-family"> sans-serif </xsl:attribute>
      <xsl:attribute name="space-before.conditionality"> retain </xsl:attribute>
      <xsl:attribute name="text-align"> justify </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="legal-page-para">
      <xsl:attribute name="font-size"> 8pt </xsl:attribute>
      <xsl:attribute name="font-family"> sans-serif </xsl:attribute>
      <xsl:attribute name="space-before.optimum"> 6pt </xsl:attribute>
      <xsl:attribute name="space-before.conditionality"> retain </xsl:attribute>
      <xsl:attribute name="text-align"> justify </xsl:attribute>
      <xsl:attribute name="space-after.optimum"> 6pt </xsl:attribute>
   </xsl:attribute-set>

   <!-- =============================================================== -->
   <!-- Attribute sets: Miscellaneous                                   -->
   <!-- =============================================================== -->

   <xsl:attribute-set name="title-attrs">
      <xsl:attribute name="color">
         <xsl:value-of select="$title-color"/>
      </xsl:attribute>
      <xsl:attribute name="font-family"> sans-serif </xsl:attribute>
      <xsl:attribute name="font-stretch"> semi-condensed </xsl:attribute>
      <xsl:attribute name="font-weight"> bold </xsl:attribute>
      <xsl:attribute name="keep-together.within-column"> always </xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column"> always </xsl:attribute>
      <xsl:attribute name="text-align"> start </xsl:attribute>
      <xsl:attribute name="space-after.optimum"> 6pt </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="href-attrs">
      <xsl:attribute name="color">
         <xsl:value-of select="$href-color"/>
      </xsl:attribute>
      <xsl:attribute name="text-decoration">underline</xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="header-attrs">
      <xsl:attribute name="font-size"> 9pt </xsl:attribute>
      <xsl:attribute name="font-family"> sans-serif </xsl:attribute>
      <xsl:attribute name="font-style"> normal </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="preface-title-attrs">
      <xsl:attribute name="color">
         <xsl:value-of select="$title-color"/>
      </xsl:attribute>
      <xsl:attribute name="font-family"> sans-serif </xsl:attribute>
      <xsl:attribute name="font-stretch"> semi-condensed </xsl:attribute>
      <xsl:attribute name="font-weight"> bold </xsl:attribute>
      <xsl:attribute name="keep-together.within-column"> always </xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column"> always </xsl:attribute>
      <xsl:attribute name="text-align"> start </xsl:attribute>
      <xsl:attribute name="space-before.optimum"> 18pt </xsl:attribute>
      <xsl:attribute name="space-after.optimum"> 18pt </xsl:attribute>
      <xsl:attribute name="font-size"> 22pt </xsl:attribute>
   </xsl:attribute-set>

   <xsl:attribute-set name="article-title-attrs">
      <xsl:attribute name="page-break-before"> always </xsl:attribute>
      <xsl:attribute name="font-size"> 30pt </xsl:attribute>
      <xsl:attribute name="space-after.optimum"> 30pt </xsl:attribute>
      <xsl:attribute name="color">
         <xsl:value-of select="$title-color"/>
      </xsl:attribute>
      <xsl:attribute name="font-family"> sans-serif </xsl:attribute>
      <xsl:attribute name="font-stretch"> semi-condensed </xsl:attribute>
      <xsl:attribute name="font-weight"> bold </xsl:attribute>
      <xsl:attribute name="keep-together.within-column"> always </xsl:attribute>
      <xsl:attribute name="keep-with-next.within-column"> always </xsl:attribute>
      <xsl:attribute name="text-align"> start </xsl:attribute>
   </xsl:attribute-set>

   <!-- *************************************************************** -->
   <!-- Top-level template: document layout for a book                  -->
   <!-- *************************************************************** -->

   <xsl:template match="book">
      <fo:root hyphenation-push-character-count="3"
               hyphenation-remain-character-count="3">
         <rx:meta-info>
            <rx:meta-field name="title"
                           value="{string(title)}"/>
            <rx:meta-field name="author"
                           value="InterSystems Corporation"/>
            <rx:meta-field name="subject"
                           value="Product Documentation"/>
         </rx:meta-info>
         <fo:layout-master-set>
            <fo:simple-page-master master-name="cover-page"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="cover-page-margins"/>
               <fo:region-before extent="2.0in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="0.8in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="blank-page"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="blank-page-margins"
                               display-align="after"/>
               <fo:region-after extent="1in"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="bare-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="bare-page-left-margins"/>
               <fo:region-after extent=".5in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="bare-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="bare-page-right-margins"/>
               <fo:region-after extent=".5in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="first-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="first-page-right-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="first-header"/>
               <fo:region-after extent=".5in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="regular-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="regular-page-left-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="left-header"/>
               <fo:region-after extent=".5in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="regular-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="regular-page-right-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent=".5in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="contents-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="contents-page-left-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="left-header"/>
               <fo:region-after extent="1in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="contents-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="contents-page-right-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="1in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="first-index-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="first-page-right-margins"
                               column-count="2"
                               column-gap="0.2in"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="1in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="index-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="index-page-left-margins"
                               column-count="2"
                               column-gap="0.2in"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="left-header"/>
               <fo:region-after extent="1in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="index-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="index-page-right-margins"
                               column-count="2"
                               column-gap="0.2in"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="1in"
                                region-name="right-footer"/>
            </fo:simple-page-master>

            <!-- Sequences -->

            <fo:page-sequence-master master-name="cover">
               <fo:single-page-master-reference master-reference="cover-page"/>
            </fo:page-sequence-master>
            <fo:page-sequence-master master-name="TOC">
               <fo:repeatable-page-master-alternatives>
                  <fo:conditional-page-master-reference blank-or-not-blank="blank"
                                                        master-reference="blank-page"/>
                  <fo:conditional-page-master-reference odd-or-even="odd"
                                                        master-reference="contents-page-right"/>
                  <fo:conditional-page-master-reference odd-or-even="even"
                                                        master-reference="contents-page-left"/>
               </fo:repeatable-page-master-alternatives>
            </fo:page-sequence-master>
            <fo:page-sequence-master master-name="body">
               <fo:repeatable-page-master-alternatives>
                  <fo:conditional-page-master-reference page-position="first"
                                                        master-reference="first-page-right"/>
                  <fo:conditional-page-master-reference blank-or-not-blank="blank"
                                                        master-reference="blank-page"/>
                  <fo:conditional-page-master-reference odd-or-even="odd"
                                                        master-reference="regular-page-right"/>
                  <fo:conditional-page-master-reference odd-or-even="even"
                                                        master-reference="regular-page-left"/>
               </fo:repeatable-page-master-alternatives>
            </fo:page-sequence-master>
            <fo:page-sequence-master master-name="index-pages">
               <fo:repeatable-page-master-alternatives>
                  <fo:conditional-page-master-reference blank-or-not-blank="blank"
                                                        master-reference="blank-page"/>
                  <fo:conditional-page-master-reference odd-or-even="odd"
                                                        master-reference="index-page-right"/>
                  <fo:conditional-page-master-reference odd-or-even="even"
                                                        master-reference="index-page-left"/>
               </fo:repeatable-page-master-alternatives>
            </fo:page-sequence-master>
         </fo:layout-master-set>

         <!-- Book/article bookmarks -->

         <xsl:call-template name="outline"/>

         <!-- Book/article cover page -->

         <xsl:apply-templates select="title"/>

         <!-- Book/article legal notices -->

         <xsl:call-template name="legal-notices"/>

         <!-- Book table of contents -->

         <xsl:call-template name="book-toc"/>

         <!-- prefaces, chapters, appedixes, glossaries, or references -->

         <xsl:call-template name="book-body"/>

         <!-- Book/article index -->

         <xsl:if test="//indexterm">
            <xsl:call-template name="book-index"/>
         </xsl:if>
      </fo:root>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Top-level template: document layout for an article              -->
   <!-- *************************************************************** -->

   <xsl:template match="article">
      <fo:root hyphenation-push-character-count="3"
               hyphenation-remain-character-count="3">
         <rx:meta-info>
            <rx:meta-field name="title"
                           value="{string(title)}"/>
            <rx:meta-field name="author"
                           value="InterSystems Corporation"/>
            <rx:meta-field name="subject"
                           value="Product Documentation"/>
            <xsl:apply-templates select="articleinfo"
                                 mode="meta-info"/>
         </rx:meta-info>

         <!-- Page Layout -->

         <fo:layout-master-set>
            <fo:simple-page-master master-name="cover-page"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="cover-page-margins"/>
               <fo:region-before extent="2.0in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="0.8in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="blank-page"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="blank-page-margins"
                               display-align="after"/>
               <fo:region-after extent="1in"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="bare-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="bare-page-left-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="left-header"/>
               <fo:region-after extent=".5in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="bare-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="bare-page-right-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent=".5in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="first-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="first-page-right-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="first-header"/>
               <fo:region-after extent=".5in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="contents-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="contents-page-left-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="left-header"/>
               <fo:region-after extent="1in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="contents-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="contents-page-right-margins"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="1in"
                                region-name="right-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="index-page-left"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="index-page-left-margins"
                               column-count="2"
                               column-gap="0.2in"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="left-header"/>
               <fo:region-after extent="1in"
                                region-name="left-footer"/>
            </fo:simple-page-master>
            <fo:simple-page-master master-name="index-page-right"
                                   xsl:use-attribute-sets="page-dimensions">
               <fo:region-body xsl:use-attribute-sets="index-page-right-margins"
                               column-count="2"
                               column-gap="0.2in"/>
               <fo:region-before extent="0.6in"
                                 display-align="after"
                                 region-name="right-header"/>
               <fo:region-after extent="1in"
                                region-name="right-footer"/>
            </fo:simple-page-master>

            <!-- Sequences -->

            <fo:page-sequence-master master-name="cover">
               <fo:single-page-master-reference master-reference="cover-page"/>
            </fo:page-sequence-master>
            <fo:page-sequence-master master-name="TOC">
               <fo:repeatable-page-master-alternatives>
                  <fo:conditional-page-master-reference blank-or-not-blank="blank"
                                                        master-reference="blank-page"/>
                  <fo:conditional-page-master-reference odd-or-even="odd"
                                                        master-reference="contents-page-right"/>
                  <fo:conditional-page-master-reference odd-or-even="even"
                                                        master-reference="contents-page-left"/>
               </fo:repeatable-page-master-alternatives>
            </fo:page-sequence-master>
            <fo:page-sequence-master master-name="body">
               <fo:repeatable-page-master-alternatives>
                  <fo:conditional-page-master-reference page-position="first"
                                                        master-reference="first-page-right"/>
                  <fo:conditional-page-master-reference blank-or-not-blank="blank"
                                                        master-reference="blank-page"/>
                  <fo:conditional-page-master-reference odd-or-even="odd"
                                                        master-reference="bare-page-right"/>
                  <fo:conditional-page-master-reference odd-or-even="even"
                                                        master-reference="bare-page-left"/>
               </fo:repeatable-page-master-alternatives>
            </fo:page-sequence-master>
            <fo:page-sequence-master master-name="index-pages">
               <fo:repeatable-page-master-alternatives>
                  <fo:conditional-page-master-reference blank-or-not-blank="blank"
                                                        master-reference="blank-page"/>
                  <fo:conditional-page-master-reference odd-or-even="odd"
                                                        master-reference="index-page-right"/>
                  <fo:conditional-page-master-reference odd-or-even="even"
                                                        master-reference="index-page-left"/>
               </fo:repeatable-page-master-alternatives>
            </fo:page-sequence-master>
         </fo:layout-master-set>

         <!-- Book/article cover page -->

         <xsl:apply-templates select="title"/>

         <!-- Book/article legal notices -->

         <xsl:call-template name="legal-notices"/>

         <!-- Book/article table of contents -->

         <xsl:call-template name="book-toc"/>

         <!-- Article flow of content -->

         <xsl:call-template name="article-body"/>

         <!-- Book/article index -->

         <xsl:if test="//indexterm">
            <xsl:call-template name="book-index"/>
         </xsl:if>
      </fo:root>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Book/article legal Notices                                      -->
   <!-- *************************************************************** -->

   <xsl:template name="legal-notices">
      <fo:page-sequence master-reference="body"
                        initial-page-number="2"
                        format="i"
                        force-page-count="auto"
                        id="TOClegal">
         <fo:static-content flow-name="left-footer">
            <fo:block text-align="center"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0in 0.9in 0.2in 0.5in"
                      margin="0pt">
               <fo:block padding-top="6pt"> &nbsp; </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="center"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0in 0.5in 0.2in 0.9in"
                      margin="0pt">
               <fo:block padding-top="6pt"> &nbsp; </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body"
                  font="11pt/1.3 serif"
                  text-align="justify">
            <fo:block xsl:use-attribute-sets="legal-page-hdr-para">
               <xsl:if test="ancestor-or-self::book">
                  <fo:wrapper font-style="italic">
                     <xsl:value-of select="$opus"/>
                  </fo:wrapper>
               </xsl:if>
               <xsl:if test="ancestor-or-self::article">
                  <fo:wrapper font-style="italic">
                     <xsl:value-of select="$junior"/>
                  </fo:wrapper>
               </xsl:if>
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-hdr-para">
               <xsl:if test="ancestor-or-self::book">
                  <xsl:value-of select="$bookproduct"/>
                  &nbsp;&nbsp; 
                  <xsl:text>Version </xsl:text>
                  <xsl:value-of select="$bookrelease"/>
                  &nbsp;&nbsp; 
                  <xsl:value-of select="$bookdate"/>
                  &nbsp;&nbsp; 
                  <xsl:value-of select="$bookissue"/>
               </xsl:if>
               <xsl:if test="ancestor-or-self::article">
                  <xsl:value-of select="$articleproduct"/>
                  &nbsp;&nbsp; 
                  <xsl:text>Version </xsl:text>
                  <xsl:value-of select="$articlerelease"/>
                  &nbsp;&nbsp; 
                  <xsl:text>
                  </xsl:text>
                  <xsl:value-of select="$articledate"/>
                  &nbsp;&nbsp; 
                  <xsl:text>
                  </xsl:text>
                  <xsl:value-of select="$articleissue"/>
               </xsl:if>
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-hdr-para"> Copyright &copy; 2005 InterSystems Corporation. </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-hdr-para"> All rights reserved. </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 This book was assembled and formatted in Adobe
                Page Description Format (PDF) using tools and
                information from the following sources: Sun
                Microsystems, RenderX, Inc., Adobe Systems, and
                the World Wide Web Consortium at www.w3c.org. The
                primary document development tools were
                special-purpose XML-processing applications built
                by InterSystems using Cach&eacute; and Java.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
               <fo:external-graphic content-width="0.83in"
                                    src="url('../Logos/Cache.jpg')"/>
                 &nbsp;&nbsp; The Cach&eacute; product and its
                logos are trademarks of InterSystems Corporation.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
               <fo:external-graphic content-width="1.0in"
                                    src="url('../Logos/ensemble-logo-small.jpg')"/>
                 &nbsp;&nbsp; The Ensemble product and its logos
                are trademarks of InterSystems Corporation.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
               <fo:external-graphic content-width="1.0in"
                                    src="url('../Logos/InterSystems-small.jpg')"/>
                 &nbsp;&nbsp; The InterSystems name and logo are
                trademarks of InterSystems Corporation.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 This document contains trade secret and
                confidential information which is the property of
                InterSystems Corporation, One Memorial Drive,
                Cambridge, MA 02142, or its affiliates, and is
                furnished for the sole purpose of the operation
                and maintenance of the products of InterSystems
                Corporation. No part of this publication is to be
                used for any other purpose, and this publication
                is not to be reproduced, copied, disclosed,
                transmitted, stored in a retrieval system or
                translated into any human or computer language,
                in any form, by any means, in whole or in part,
                without the express prior written consent of
                InterSystems Corporation.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 The copying, use and disposition of this
                document and the software programs described
                herein is prohibited except to the limited extent
                set forth in the standard software license
                agreement(s) of InterSystems Corporation covering
                such programs and related documentation.
                InterSystems Corporation makes no representations
                and warranties concerning such software programs
                other than those set forth in such standard
                software license agreement(s). In addition, the
                liability of InterSystems Corporation for any
                losses or damages relating to or arising out of
                the use of such software programs is limited in
                the manner set forth in such standard software
                license agreement(s).
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 THE FOREGOING IS A GENERAL SUMMARY OF THE
                RESTRICTIONS AND LIMITATIONS IMPOSED BY
                INTERSYSTEMS CORPORATION ON THE USE OF, AND
                LIABILITY ARISING FROM, ITS COMPUTER SOFTWARE.
                FOR COMPLETE INFORMATION REFERENCE SHOULD BE MADE
                TO THE STANDARD SOFTWARE LICENSE AGREEMENT(S) OF
                INTERSYSTEMS CORPORATION, COPIES OF WHICH WILL BE
                MADE AVAILABLE UPON REQUEST.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 InterSystems Corporation disclaims
                responsibility for errors which may appear in
                this document, and it reserves the right, in its
                sole discretion and without notice, to make
                substitutions and modifications in the products
                and practices described in this document.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 Cach&eacute;, InterSystems Cach&eacute;,
                Cach&eacute; SQL, Cach&eacute; ObjectScript,
                Cach&eacute; Object, Ensemble, InterSystems
                Ensemble, Ensemble Object, and Ensemble
                Production are trademarks of InterSystems
                Corporation. All other brand or product names
                used herein are trademarks or registered
                trademarks of their respective companies or
                organizations.
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para">
                 For Support questions about any InterSystems
                products, contact:
            </fo:block>
            <fo:block xsl:use-attribute-sets="legal-page-para"
                      text-align="center">
               <fo:table-and-caption width="5.5in">
                  <fo:table-caption text-align="center">
                     <fo:block font-weight="bold">InterSystems Worldwide Customer Support</fo:block>
                  </fo:table-caption>
                  <fo:table>
                     <fo:table-column column-number="1"
                                      column-width="1.25in"/>
                     <fo:table-column column-number="2"
                                      column-width="1.00in"/>
                     <fo:table-column column-number="3"
                                      column-width="0.25in"/>
                     <fo:table-column column-number="4"
                                      column-width="1.75in"/>
                     <fo:table-column column-number="5"
                                      column-width="1.25in"/>
                     <fo:table-body>
                        <fo:table-row>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="right">Tel:</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">+1&nbsp;&nbsp;617&nbsp;&nbsp;621-0700</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                        </fo:table-row>
                        <fo:table-row>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="right">Fax:</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">+1&nbsp;&nbsp;617&nbsp;&nbsp;374-9391</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                        </fo:table-row>
                        <fo:table-row>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="right">Email:</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">support@InterSystems.com</fo:block>
                           </fo:table-cell>
                           <fo:table-cell>
                              <fo:block text-align="left">&nbsp;</fo:block>
                           </fo:table-cell>
                        </fo:table-row>
                     </fo:table-body>
                  </fo:table>
               </fo:table-and-caption>
            </fo:block>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Article flow of content                                         -->
   <!-- *************************************************************** -->

   <xsl:template name="article-body">
      <fo:page-sequence master-reference="body"
                        initial-page-number="1"
                        format="1"
                        force-page-count="end-on-even">
         <fo:static-content flow-name="left-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="6pt 0.9in 0.2in 0.5in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <fo:page-number/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:value-of select="$junior"/>
                  </fo:inline>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="start"
                      xsl:use-attribute-sets="header-attrs"
                      padding="6pt 0.5in 0.2in 0.9in"
                      text-align-last="justify"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <xsl:value-of select="$junior"/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <fo:page-number/>
                  </fo:inline>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="xsl-footnote-separator">
            <fo:block padding-top="3pt"
                      padding-bottom="3pt">
               <fo:leader leader-pattern="rule"
                          leader-length="50%"
                          rule-style="solid"
                          rule-thickness="0.5pt"
                          color="gray"/>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="left-header">
            <fo:block text-align="start"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt 0.9in 6pt .5in"
                      margin="0pt">
               <fo:block border-bottom="thin solid #808080"
                         padding-bottom="1pt">
                  <fo:retrieve-marker retrieve-class-name="topofarticleheader"
                                      retrieve-position="first-starting-within-page"
                                      retrieve-boundary="page"/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-header">
            <fo:block text-align="end"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt .5in 6pt 0.9in"
                      margin="0pt">
               <fo:block border-bottom="thin solid #808080"
                         padding-bottom="1pt">
                  <fo:retrieve-marker retrieve-class-name="topofarticleheader"
                                      retrieve-position="first-starting-within-page"
                                      retrieve-boundary="page"/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="first-header">
            <fo:block text-align="end"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt .5in 6pt 0.9in"
                      margin="0pt">
            </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body"
                  font="11pt/1.3 serif"
                  text-align="justify">
            <fo:block id="article-start"
                      xsl:use-attribute-sets="article-title-attrs">
               <xsl:value-of select="$junior"/>
            </fo:block>
            <fo:block>
               <xsl:apply-templates select="*[not(self::title or self::articleinfo or self::abstract or self::subtitle or self::artheader or ancestor-or-self::lot)]"/>
            </fo:block>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Book/article cover Page                                         -->
   <!-- *************************************************************** -->

   <xsl:template match="book/title | article/title">
      <fo:page-sequence master-reference="cover"
                        id="cover-page"
                        force-page-count="no-force">
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="center"
                      font-size="8pt"
                      font-family="sans-serif">
                 InterSystems Corporation&nbsp;&nbsp;&nbsp;1
                Memorial Drive&nbsp;&nbsp;&nbsp;Cambridge MA
                02142&nbsp;&nbsp;&nbsp;www.intersystems.com
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-header">
            <fo:block text-align="center"
                      font-size="8pt"
                      font-family="sans-serif"
                      padding-top="0pt"
                      margin-left="32pt">
               <xsl:if test="ancestor-or-self::book">
                  <xsl:choose>
                     <xsl:when test="$bookproduct = 'Cach&eacute;'">
                        <fo:block text-align="center">
                           <fo:external-graphic content-width="2.4in"
                                                src="url('../Logos/Cache.jpg')"/>
                        </fo:block>
                     </xsl:when>
                     <xsl:when test="$bookproduct = 'Ensemble'">
                        <fo:block text-align="center">
                           <fo:external-graphic content-width="2.8in"
                                                src="url('../Logos/ensemble-logo-small.jpg')"/>
                        </fo:block>
                     </xsl:when>
                     <xsl:otherwise>
                        <fo:block text-align="center">
                           <fo:external-graphic content-width="3.0in"
                                                src="url('../Logos/InterSystems-small.jpg')"/>
                        </fo:block>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:if>
               <xsl:if test="ancestor-or-self::article">
                  <xsl:choose>
                     <xsl:when test="$articleproduct = 'Cach&eacute;'">
                        <fo:block text-align="center">
                           <fo:external-graphic content-width="2.4in"
                                                src="url('../Logos/Cache.jpg')"/>
                        </fo:block>
                     </xsl:when>
                     <xsl:when test="$articleproduct = 'Ensemble'">
                        <fo:block text-align="center">
                           <fo:external-graphic content-width="2.8in"
                                                src="url('../Logos/ensemble-logo-small.jpg')"/>
                        </fo:block>
                     </xsl:when>
                     <xsl:otherwise>
                        <fo:block text-align="center">
                           <fo:external-graphic content-width="3.0in"
                                                src="url('../Logos/InterSystems-small.jpg')"/>
                        </fo:block>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:if>
            </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body">
            <fo:block-container height="6.24in"
                                display-align="center">
               <fo:block text-align="left"
                         font-size="8pt"
                         font-family="sans-serif"
                         padding-top="0pt">                       
                  <xsl:if test="ancestor-or-self::book">
                     <fo:block text-align="center"
                               font-size="36pt"
                               font-family="serif"
                               padding-top="150pt">
                        <xsl:apply-templates/>
                     </fo:block>
                     <fo:block text-align="center"
                               font-family="serif"
                               font-size="18pt"
                               padding-top="24pt">
                         Version 
                        <xsl:value-of select="$bookrelease"/>
                     </fo:block>
                     <fo:block text-align="center"
                               font-family="serif"
                               font-size="18pt"
                               padding-top="0pt">
                        <xsl:value-of select="$bookdate"/>
                     </fo:block>
                     <fo:block text-align="center"
                               space-before.optimum="0pt"
                               font-family="serif"
                               font-size="18pt">
                        <xsl:value-of select="$bookissue"/>
                     </fo:block>
                  </xsl:if>
                  <xsl:if test="ancestor-or-self::article">
                     <fo:block text-align="center"
                               font-size="36pt"
                               font-family="serif"
                               padding-top="150pt">
                        <xsl:apply-templates/>
                     </fo:block>
                     <fo:block text-align="center"
                               font-family="serif"
                               font-size="18pt"
                               padding-top="24pt">
                         Version 
                        <xsl:value-of select="$articlerelease"/>
                     </fo:block>
                     <fo:block text-align="center"
                               font-family="serif"
                               font-size="18pt"
                               padding-top="0pt">
                        <xsl:value-of select="$articledate"/>
                     </fo:block>
                     <fo:block text-align="center"
                               space-before.optimum="0pt"
                               font-family="serif"
                               font-size="18pt">
                        <xsl:value-of select="$articleissue"/>
                     </fo:block>
                  </xsl:if>
                  <xsl:if test="//remark">
                     
                           <fo:table space-before.optimum="9pt">
		              <fo:table-column column-width="36pt"/>
		              <fo:table-body>
		                 <fo:table-row>
		                    <fo:table-cell background-color="black" padding-top="3pt">
		                       <fo:block background-color="black" color="white" font-size="36pt" font-weight="bold" font-family="sans-serif" text-align="center">?</fo:block>
		                    </fo:table-cell>
		                    <fo:table-cell background-color="yellow" padding-top="6pt" padding-bottom="6pt" padding-left="9pt" padding-right="9pt">
		                       <fo:block font-size="11pt"
		                                 font-family="sans-serif"
		                                 font-weight="bold" 
		                                 space-after.optimum="2pt">
		                          Comments/Questions for Reviewers of This Draft 
		                       </fo:block>
		                       <fo:block font-size="10pt"
		                                 font-family="sans-serif">
		                          This document is a preliminary draft for InterSystems internal use only.
		                          Text blocks like this one 
		                          contain comments and questions for reviewers.
		                       </fo:block>
		                    </fo:table-cell>
		                 </fo:table-row>
		              </fo:table-body>
		           </fo:table>

                  </xsl:if>
               </fo:block>
            </fo:block-container>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Prefaces, Chapters, Appendixes, and Glossaries                  -->
   <!-- *************************************************************** -->

   <xsl:template match="preface | chapter | appendix | glossary">
      <fo:page-sequence master-reference="body"
                        force-page-count="end-on-even"
                        format="1">

         <!-- if there is something in the book before me, continue page numbers; otherwise start at 1 -->

         <xsl:attribute name="initial-page-number">
            <xsl:choose>
               <xsl:when test="count(preceding-sibling::chapter | preceding-sibling::appendix | preceding-sibling::glossary | preceding-sibling::reference | preceding-sibling::preface) &gt; 0">

                  <!-- When something is before me -->

                   auto 

                  <!-- I am not the first item in the book -->

               </xsl:when>
               <xsl:otherwise>
                   1 

                  <!-- Otherwise I am the first -->

               </xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <fo:static-content flow-name="left-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="6pt 0.9in 0.2in 0.5in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <fo:page-number/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                     <xsl:value-of select="$opus"/>
                  </fo:inline>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="6pt 0.5in 0.2in 0.9in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <xsl:value-of select="$opus"/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                  </fo:inline>
                  <fo:page-number/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="xsl-footnote-separator">
            <fo:block padding-top="3pt"
                      padding-bottom="3pt">
               <fo:leader leader-pattern="rule"
                          leader-length="50%"
                          rule-style="solid"
                          rule-thickness="0.5pt"
                          color="gray"/>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="left-header">
            <fo:block text-align="start"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt 0.9in 6pt .5in"
                      margin="0pt">
               <fo:block border-bottom="thin solid #808080"
                         padding-bottom="1pt">
                  <fo:retrieve-marker retrieve-class-name="topofleftpageheader"
                                      retrieve-position="first-starting-within-page"
                                      retrieve-boundary="page"/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-header">
            <fo:block text-align="end"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt .5in 6pt 0.9in"
                      margin="0pt">
               <fo:block border-bottom="thin solid #808080"
                         padding-bottom="1pt">
                  <fo:retrieve-marker retrieve-class-name="topofrightpageheader"
                                      retrieve-position="first-starting-within-page"
                                      retrieve-boundary="page"/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="first-header">
            <fo:block text-align="end"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt .5in 6pt 0.9in"
                      margin="0pt"> &nbsp; </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body"
                  font="11pt/1.3 serif"
                  text-align="justify">
            <xsl:variable name="linkid"
                          select="@id"/>
            <fo:block id="{$linkid}">

               <!-- Left header is always the chapter (or appendix or glossary) title -->

               <fo:marker marker-class-name="topofleftpageheader">
                  <fo:wrapper xsl:use-attribute-sets="header-attrs">
                     <xsl:apply-templates select="title"
                                          mode="header"/>
                  </fo:wrapper>
               </fo:marker>

               <!-- If no subsections are present, set right header same as left -->

               <xsl:choose>
                  <xsl:when test="count(child::sect1 | child::glossentry) &gt; 0">

                     <!-- There are subsections that will serve as right headers              -->
                     <!-- This test is true when a chapter or appendix contains a sect1       -->
                     <!-- This test is true when a glossary contains a glossentry             -->
                     <!-- This test is false when a chapter contains a glosslist but no sect1 -->

                  </xsl:when>
                  <xsl:otherwise>

                     <!-- There are no subsections that can serve as right headers            -->
                     <!-- Set right header to chapter (or appendix or glossary) title         -->

                     <fo:marker marker-class-name="topofrightpageheader">
                        <fo:wrapper xsl:use-attribute-sets="header-attrs">
                           <xsl:apply-templates select="title"
                                                mode="header"/>
                        </fo:wrapper>
                     </fo:marker>
                  </xsl:otherwise>
               </xsl:choose>
               <xsl:apply-templates select="title"/>
               <fo:block>
                  <xsl:apply-templates select="*[not(self::title | self::subtitle)]"/>
               </fo:block>
            </fo:block>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- References                                                      -->
   <!-- *************************************************************** -->

   <xsl:template match="reference">
      <fo:page-sequence master-reference="body"
                        force-page-count="end-on-even"
                        format="1">

         <!-- if there is a reference before me, continue page numbers; otherwise start -->

         <xsl:attribute name="initial-page-number">
            <xsl:choose>
               <xsl:when test="count(preceding-sibling::reference | preceding-sibling::chapter | preceding-sibling::preface) = 0">1</xsl:when>
               <xsl:otherwise>auto</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <fo:static-content flow-name="left-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="6pt 0.9in 0.2in 0.5in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <fo:page-number/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                     <xsl:value-of select="$opus"/>
                  </fo:inline>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="6pt 0.5in 0.2in 0.9in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <xsl:value-of select="$opus"/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                  </fo:inline>
                  <fo:page-number/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="xsl-footnote-separator">
            <fo:block padding-top="3pt"
                      padding-bottom="3pt">
               <fo:leader leader-pattern="rule"
                          leader-length="50%"
                          rule-style="solid"
                          rule-thickness="0.5pt"
                          color="gray"/>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="left-header">
            <fo:block text-align="start"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt 0.9in 6pt .5in"
                      margin="0pt">
               <fo:block border-bottom="thin solid #808080"
                         padding-bottom="1pt">
                  <fo:retrieve-marker retrieve-class-name="topofleftpageheader"
                                      retrieve-position="first-starting-within-page"
                                      retrieve-boundary="page"/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-header">
            <fo:block text-align="end"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt .5in 6pt 0.9in"
                      margin="0pt">
               <fo:block border-bottom="thin solid #808080"
                         padding-bottom="1pt">
                  <fo:retrieve-marker retrieve-class-name="topofrightpageheader"
                                      retrieve-position="first-starting-within-page"
                                      retrieve-boundary="page"/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="first-header">
            <fo:block text-align="end"
                      xsl:use-attribute-sets="header-attrs"
                      padding="0pt .5in 6pt 0.9in"
                      margin="0pt"> &nbsp; </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body"
                  font="11pt/1.3 serif"
                  text-align="justify">
            <xsl:variable name="linkid"
                          select="@id"/>
            <fo:block id="{$linkid}">
               <fo:marker marker-class-name="topofleftpageheader">
                  <fo:wrapper xsl:use-attribute-sets="header-attrs">
                     <xsl:apply-templates select="title"
                                          mode="header"/>
                  </fo:wrapper>
               </fo:marker>
               <xsl:apply-templates select="title"/>
               <fo:block>
                  <xsl:apply-templates select="*[not(self::title | self::subtitle)]"/>
               </fo:block>
            </fo:block>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Not supported: <part> <partintro>                               -->
   <!-- *************************************************************** -->
   <!-- *************************************************************** -->
   <!-- Second-level titles in Articles                             -->
   <!-- *************************************************************** -->

   <xsl:template match="qandadiv | article/sect1">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <fo:marker marker-class-name="topofarticleheader">
            <fo:wrapper xsl:use-attribute-sets="header-attrs">
               <xsl:apply-templates select="title"
                                    mode="header"/>
            </fo:wrapper>
         </fo:marker>
         <xsl:apply-templates select="title"/>
         <fo:block>
            <xsl:apply-templates select="*[not(self::title)]"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Second-level and other titles in Books                          -->
   <!-- *************************************************************** -->

   <xsl:template match="sect1">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <fo:marker marker-class-name="topofrightpageheader">
            <fo:wrapper xsl:use-attribute-sets="header-attrs">
               <xsl:apply-templates select="title"
                                    mode="header"/>
            </fo:wrapper>
         </fo:marker>
         <xsl:apply-templates select="title"/>
         <fo:block>
            <xsl:apply-templates select="*[not(self::title)]"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <xsl:template match="section | sect2 | sect3 | sect4 | */qandaset">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <xsl:apply-templates select="title"/>
         <fo:block>
            <xsl:apply-templates select="*[not(self::title)]"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <xsl:template match="refsect1 | refsect2 | refsect3">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <xsl:apply-templates select="title"/>
         <fo:block>
            <xsl:apply-templates select="*[not(self::title)]"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <xsl:template match="reference/refentry">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <fo:marker marker-class-name="topofrightpageheader">
            <fo:wrapper xsl:use-attribute-sets="header-attrs">
               <xsl:apply-templates select="refmeta/refentrytitle"
                                    mode="header"/>
            </fo:wrapper>
         </fo:marker>
         <xsl:apply-templates select="refmeta/refentrytitle"/>
         <fo:block>
            <xsl:apply-templates select="*[not(self::refmeta)]"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <xsl:template match="article/refentry">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <fo:marker marker-class-name="topofarticleheader">
            <fo:wrapper xsl:use-attribute-sets="header-attrs">
               <xsl:apply-templates select="refmeta/refentrytitle"
                                    mode="header"/>
            </fo:wrapper>
         </fo:marker>
         <xsl:apply-templates select="refmeta/refentrytitle"/>
         <fo:block>
            <xsl:apply-templates select="*[not(self::refmeta)]"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <xsl:template match="refnamediv">
      <fo:block>
         <xsl:apply-templates select="*[not(self::refname | self::refdescriptor)]"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="refsynopsisdiv">
      <fo:block>

         <!--     select="*[not(self::refsect2)]"    -->

         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- All titles: styles for how they appear in running text          -->
   <!-- *************************************************************** -->

   <xsl:template match="chapter/title | appendix/title | glossary/title | reference/title | preface/title | qandaset/title[count(ancestor::article) = 1]">
      <xsl:choose>
         <xsl:when test="ancestor::chapter">
            <fo:block page-break-before="always"
                      font="72pt/0.9 sans-serif"
                      xsl:use-attribute-sets="title-attrs"
                      space-before.conditionality="retain"
                      space-before.optimum="42pt">
               <xsl:number format="1.1.1.1.1.1"
                           count="chapter | section | sect1 | sect2 | sect3 | sect4"
                           level="multiple"/>
            </fo:block>
            <fo:block font-size="30pt"
                      xsl:use-attribute-sets="title-attrs"
                      space-after.optimum="36pt">
               <xsl:apply-templates select="."
                                    mode="plain-text"/>
            </fo:block>
         </xsl:when>
         <xsl:when test="ancestor::appendix">
            <fo:block page-break-before="always"
                      font="72pt/0.9 sans-serif"
                      xsl:use-attribute-sets="title-attrs"
                      space-before.conditionality="retain"
                      space-before.optimum="42pt">
               <xsl:number format="A.1.1.1.1.1"
                           count="appendix | section | sect1 | sect2 | sect3 | sect4"
                           level="multiple"/>
            </fo:block>
            <fo:block font-size="30pt"
                      xsl:use-attribute-sets="title-attrs"
                      space-after.optimum="36pt">
               <xsl:apply-templates select="."
                                    mode="plain-text"/>
            </fo:block>
         </xsl:when>
         <xsl:otherwise>
            <fo:block xsl:use-attribute-sets="article-title-attrs">
               <xsl:apply-templates select="."
                                    mode="numbered-text"/>
            </fo:block>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match="sect1/title[count(ancestor::article) = 1] | sect1/title[count(ancestor::chapter | ancestor::appendix) = 1]">
      <fo:block font-size="22pt"
                xsl:use-attribute-sets="title-attrs"
                padding-before="6pt"
                space-before.optimum="21pt"
                space-after.optimum="15pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="refmeta/refentrytitle | qandaset/title[count(ancestor::chapter | ancestor::appendix | ancestor::reference) = 1] | qandadiv/title[count(ancestor::article) = 1]">
      <fo:block font-size="20pt"
                xsl:use-attribute-sets="title-attrs"
                border-bottom="thin solid #808080"
                space-before.optimum="20pt"
                space-after.optimum="9pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="sect2/title[count(ancestor::article) = 1] | sect2/title[count(ancestor::chapter | ancestor::appendix) = 1]">
      <fo:block font-size="16pt"
                xsl:use-attribute-sets="title-attrs"
                padding-before="6pt"
                space-before.optimum="3pt"
                space-after.optimum="9pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="qandadiv/title[count(ancestor::chapter | ancestor::appendix | ancestor::reference) = 1]">
      <fo:block font-size="18pt"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="18pt"
                space-after.optimum="6pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="sect3/title[count(ancestor::article) = 1] | sect3/title[count(ancestor::chapter | ancestor::appendix) = 1] | section/title[count(ancestor::section | ancestor::chapter | ancestor::appendix) = 3]">
      <fo:block font-size="13pt"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="12pt"
                space-after.optimum="6pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="sect4/title[count(ancestor::article) = 1] | sect4/title[count(ancestor::chapter | ancestor::appendix) = 1] | formalpara/title"
                 priority="-1">
      <fo:block font-size="11pt"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="6pt"
                space-after.optimum="3pt">
         <xsl:apply-templates select="."
                              mode="plain-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="figure/title | example/title | table/title"
                 priority="-1">
      <fo:block xsl:use-attribute-sets="title-attrs"
                space-before.optimum="6pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="refsect1/title">
      <fo:block font-size="15pt"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="9pt"
                space-after.optimum="3pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="refsect2/title"
                 priority="-1">
      <fo:block font-size="13pt"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="5pt">
         <fo:wrapper font-style="italic">
            <xsl:apply-templates select="."
                                 mode="numbered-text"/>
         </fo:wrapper>
      </fo:block>
   </xsl:template>

   <xsl:template match="refsect3/title"
                 priority="-1">
      <fo:block font-size="10.5pt"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="5pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="refsect4/title"
                 priority="-1">
      <fo:block font-size="10pt"
                font-style="italic"
                xsl:use-attribute-sets="title-attrs"
                space-before.optimum="5pt">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="chapter/title"
                 mode="numbered-text">
      <xsl:number format="1.1.1.1.1.1"
                  count="chapter | section | sect1 | sect2 | sect3 | sect4"
                  level="multiple"/>
      <xsl:text>
      </xsl:text>
      <xsl:apply-templates select="."
                           mode="plain-text"/>
   </xsl:template>

   <xsl:template match="appendix/title"
                 mode="numbered-text">
      <xsl:text>Appendix </xsl:text>
      <xsl:number format="A.1.1.1.1.1"
                  count="appendix | section | sect1 | sect2 | sect3 | sect4"
                  level="multiple"/>
      <xsl:text>: </xsl:text>
      <xsl:apply-templates select="."
                           mode="plain-text"/>
   </xsl:template>

   <xsl:template match="glossary/title"
                 mode="numbered-text">
      <xsl:apply-templates select="."
                           mode="plain-text"/>
   </xsl:template>

   <xsl:template match="preface/title"
                 mode="numbered-text">
      <xsl:apply-templates select="."
                           mode="plain-text"/>
   </xsl:template>

   <xsl:template match="sect1/title | sect2/title | sect3/title | sect4/title"
                 mode="numbered-text">
      <xsl:choose>
         <xsl:when test="ancestor::chapter">
            <xsl:number format="1.1.1.1.1.1"
                        count="chapter | section | sect1 | sect2 | sect3 | sect4"
                        level="multiple"/>
            <xsl:text>
            </xsl:text>
            <xsl:apply-templates select="."
                                 mode="plain-text"/>
         </xsl:when>
         <xsl:when test="ancestor::appendix">
            <xsl:number format="A.1.1.1.1.1"
                        count="appendix | section | sect1 | sect2 | sect3 | sect4"
                        level="multiple"/>
            <xsl:text>
            </xsl:text>
            <xsl:apply-templates select="."
                                 mode="plain-text"/>
         </xsl:when>
         <xsl:when test="ancestor::article">
            <xsl:number format="1.1.1.1.1.1"
                        count="section | sect1 | sect2 | sect3 | sect4"
                        level="multiple"/>
            <xsl:text>
            </xsl:text>
            <xsl:apply-templates select="."
                                 mode="plain-text"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:apply-templates select="."
                                 mode="plain-text"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match="formalpara/title | section/title | qandadiv/title"
                 mode="numbered-text">
      <xsl:apply-templates select="."
                           mode="plain-text"/>
   </xsl:template>

   <xsl:template match="table/title | figure/title | example/title"
                 mode="numbered-text">
      <fo:wrapper font-style="italic">
         <xsl:text>
         </xsl:text>
         <xsl:apply-templates select="."
                              mode="plain-text"/>
      </fo:wrapper>
   </xsl:template>

   <xsl:template match="title"
                 mode="plain-text">
      <xsl:apply-templates/>
   </xsl:template>
   <xsl:template match="*"
                 mode="toc"
                 priority="-1"/>
   <xsl:template match="*"
                 mode="toc-sect2"
                 priority="-1"/>

   <xsl:template match="preface | chapter | appendix | glossary"
                 mode="toc">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block space-before.optimum="6pt"
                text-align-last="justify"
                font-weight="bold">
         <fo:basic-link internal-destination="{$linkid}"
                        color="{$href-color}">
            <xsl:apply-templates select="title"
                                 mode="numbered-text"/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
      <fo:block>
         <xsl:if test="sect1">
            <fo:block>
               <xsl:apply-templates mode="toc"/>
            </fo:block>
         </xsl:if>
      </fo:block>
   </xsl:template>

   <xsl:template match="qandaset"
                 mode="toc">
      <fo:block>
         <xsl:if test="qandadiv">
            <fo:block>
               <xsl:apply-templates mode="toc"/>
            </fo:block>
         </xsl:if>
      </fo:block>
   </xsl:template>

   <xsl:template match="reference"
                 mode="toc">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block space-before.optimum="6pt"
                text-align-last="justify"
                font-weight="bold">
         <fo:basic-link internal-destination="{$linkid}"
                        color="{$href-color}">
            <xsl:apply-templates select="title"
                                 mode="numbered-text"/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
      <fo:block>
         <xsl:if test="refentry">
            <fo:block>
               <xsl:apply-templates mode="toc"/>
            </fo:block>
         </xsl:if>
      </fo:block>
   </xsl:template>

   <xsl:template match="sect1"
                 mode="toc">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block start-indent="0.25in"
                text-align-last="justify">
         <fo:basic-link internal-destination="{$linkid}"
                        color="{$href-color}">
            <xsl:apply-templates select="title"
                                 mode="numbered-text"/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
      <fo:block>
         <xsl:if test="sect2">
            <xsl:choose>
               <xsl:when test="starts-with($bookid,'R_')">
               </xsl:when>
               <xsl:otherwise>
                  <fo:block>
                     <xsl:apply-templates mode="toc-sect2"/>
                  </fo:block>
               </xsl:otherwise>
            </xsl:choose>
         </xsl:if>
      </fo:block>
   </xsl:template>

   <xsl:template match="sect2"
                 mode="toc-sect2">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block start-indent="0.5in"
                text-align-last="justify">
         <fo:basic-link internal-destination="{$linkid}"
                        color="{$href-color}">
            <xsl:apply-templates select="title"
                                 mode="numbered-text"/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
   </xsl:template>

   <xsl:template match="qandadiv"
                 mode="toc">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block start-indent="0.25in"
                text-align-last="justify">
         <fo:basic-link internal-destination="{$linkid}"
                        color="{$href-color}">
            <xsl:apply-templates select="title"
                                 mode="numbered-text"/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
   </xsl:template>

   <xsl:template match="refentry"
                 mode="toc">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block start-indent="0.25in"
                text-align-last="justify">
         <fo:basic-link internal-destination="{$linkid}"
                        color="{$href-color}">
            <xsl:apply-templates select="refmeta/refentrytitle"
                                 mode="numbered-text"/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
   </xsl:template>

   <xsl:template match="book/lot"
                 mode="lot">
      <xsl:variable name="linkid"
                    select="@label"/>
      <fo:block page-break-before="always"
                keep-together.within-page="always"
                xsl:use-attribute-sets="preface-title-attrs"
                id="{$linkid}">
         <xsl:apply-templates select="title"/>
         <xsl:text>
         </xsl:text>
      </fo:block>
      <fo:block>
         <xsl:if test="lotentry">
            <fo:block>
               <xsl:apply-templates select="lotentry"
                                    mode="lot"/>
               <xsl:text>
               </xsl:text>
            </fo:block>
         </xsl:if>
      </fo:block>
   </xsl:template>

   <xsl:template match="book/lot/lotentry"
                 mode="lot">
      <xsl:variable name="linkid"
                    select="@linkend"/>
      <fo:block keep-with-previous.within-page="always"
                text-align-last="justify">
         <fo:basic-link color="{$href-color}"
                        internal-destination="{$linkid}">
            <xsl:apply-templates/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
   </xsl:template>

   <xsl:template match="article/lot"
                 mode="lot">
      <xsl:variable name="linkid"
                    select="@label"/>
      <fo:block text-align="start"
                space-before.optimum="24pt"
                keep-together.within-page="always"
                font-weight="bold"
                id="{$linkid}"
                color="{$href-color}">
         <xsl:apply-templates select="title"/>
         <xsl:text>
         </xsl:text>
      </fo:block>
      <fo:block>
         <xsl:if test="lotentry">
            <fo:block>
               <xsl:apply-templates select="lotentry"
                                    mode="lot"/>
            </fo:block>
         </xsl:if>
      </fo:block>
   </xsl:template>

   <xsl:template match="article/lot/lotentry"
                 mode="lot">
      <xsl:variable name="linkid"
                    select="@linkend"/>
      <fo:block margin-left="0.25in"
                keep-with-previous.within-page="always"
                text-align-last="justify">
         <fo:basic-link color="{$href-color}"
                        internal-destination="{$linkid}">
            <xsl:apply-templates/>
         </fo:basic-link>
         <xsl:text>
         </xsl:text>
         <fo:inline keep-together.within-line="always">
            <fo:leader leader-pattern="dots"/>
            <xsl:text>
            </xsl:text>
            <fo:page-number-citation ref-id="{$linkid}"/>
         </fo:inline>
      </fo:block>
   </xsl:template>
   <xsl:template match="*"
                 mode="bookmark"
                 priority="-1"/>

   <xsl:template match="preface | chapter | appendix | glossary | reference | section | sect1 | sect2 | qandadiv"
                 mode="bookmark">
      <xsl:variable name="linkid"
                    select="@id"/>

      <!-- Remove all markup from the bookmark label and normalize spaces -->

      <xsl:variable name="label-text">
         <xsl:apply-templates select="title"
                              mode="numbered-text"/>
      </xsl:variable>
      <rx:bookmark internal-destination="{$linkid}">
         <rx:bookmark-label>
            <xsl:value-of select="normalize-space($label-text)"/>
         </rx:bookmark-label>
         <xsl:apply-templates mode="bookmark"/>
      </rx:bookmark>
   </xsl:template>

   <xsl:template match="refentry"
                 mode="bookmark">
      <xsl:variable name="linkid"
                    select="@id"/>

      <!-- Remove all markup from the bookmark label and normalize spaces -->

      <xsl:variable name="label-text">
         <xsl:apply-templates select="refmeta/refentrytitle"
                              mode="numbered-text"/>
      </xsl:variable>
      <rx:bookmark internal-destination="{$linkid}">
         <rx:bookmark-label>
            <xsl:value-of select="normalize-space($label-text)"/>
         </rx:bookmark-label>
         <xsl:apply-templates mode="bookmark"/>
      </rx:bookmark>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Standard elements                                               -->
   <!-- *************************************************************** -->

   <!-- Paragraph -->

   <xsl:template match="para">
      <fo:block space-after.optimum="6pt"
                hyphenate="true">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <xsl:template match="refpurpose">
      <fo:block keep-with-previous.within-page="always"
                space-after.optimum="6pt"
                hyphenate="true">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <!-- Paragraph inside question-->

   <xsl:template match="question/para"
                 priority="2">
      <xsl:apply-templates/>
   </xsl:template>
   
   <!-- Paragraph with title -->

   <xsl:template match="formalpara">

      <!-- The following code enables internal cross-refs to those formalpara that have ids. -->

      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <fo:block keep-with-next.within-page="always">
            <xsl:apply-templates select="title"/>
         </fo:block>
         <fo:block>
            <xsl:apply-templates select="para"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <!-- Emphasis -->

   <xsl:template match="emphasis">
      <fo:inline>
         <xsl:if test="contains(@role, 'italic') or not (@role)">
            <xsl:attribute name="font-style">italic</xsl:attribute>
         </xsl:if>
         <xsl:if test="contains(@role, 'bold')">
            <xsl:attribute name="font-style">italic</xsl:attribute>
         </xsl:if>
         <xsl:if test="contains(@role, 'underline')">
            <xsl:attribute name="font-style">italic</xsl:attribute>
         </xsl:if>
         <xsl:if test="contains(@role, 'frame')">
            <xsl:attribute name="border">thin solid #808080</xsl:attribute>
            <xsl:attribute name="padding">0pt 1pt</xsl:attribute>
         </xsl:if>
         <xsl:if test="contains(@role, 'background')">
            <xsl:attribute name="background-color">silver</xsl:attribute>
            <xsl:attribute name="padding">0pt 1pt</xsl:attribute>
         </xsl:if>
         <xsl:text/>
         <xsl:apply-templates/>
         <xsl:text/>
      </fo:inline>
   </xsl:template>

   <xsl:template match="firstterm">
      <fo:inline font-weight="bold">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- Product names -->

   <xsl:template match="application | productname">

      <!-- No special formatting -->

      <fo:inline>
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- Comments -->

   <xsl:template match="comment">

      <!-- Hide it -->

   </xsl:template>

   <!-- Remarks -->

   <xsl:template match="remark">

      <fo:table space-before.optimum="6pt"
                space-after.optimum="9pt">
         <fo:table-column column-width="36pt"/>
         <fo:table-body>
            <fo:table-row>
               <fo:table-cell background-color="black" padding-top="3pt">
                  <fo:block background-color="black" color="white" font-size="36pt" font-weight="bold" font-family="sans-serif" text-align="center">?</fo:block>
               </fo:table-cell>
               <fo:table-cell background-color="yellow" padding-top="6pt" padding-bottom="6pt" padding-left="9pt" padding-right="9pt">
                  <fo:block font-size="11pt"
                            font-family="sans-serif"
                            font-weight="bold" 
                            space-after.optimum="2pt">
                     Comments/Questions for Reviewers of This Draft 
                  </fo:block>
                  <fo:block font-size="10pt"
                            font-family="sans-serif">
                     <xsl:apply-templates/>
                  </fo:block>
               </fo:table-cell>
            </fo:table-row>
         </fo:table-body>
      </fo:table>
         
   </xsl:template>

   <!-- Cited Title -->

   <xsl:template match="citetitle">
      <fo:inline font-style="italic">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- Items tagged as quotations -->

   <xsl:template match="quote">
      <fo:inline>
         &ldquo;<xsl:apply-templates/>&rdquo;
      </fo:inline>
   </xsl:template>

   <!-- O-O method names -->
   <!-- Commands typed from console -->
   <!-- Function names -->
   <!-- The names of constants -->

   <xsl:template match="method | methodname | command | function | constant">
      <fo:inline hyphenate="false"
                 font-weight="bold">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- File names -->
   <!-- Code excerpts -->
   <!-- Variables -->

   <xsl:template match="literal | computeroutput">
      <fo:inline hyphenate="false"
                 font-family="monospace"
                 font-size="9.5pt">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

 <xsl:template match="systemitem">
      <fo:inline hyphenate="false"
                 font-family="monospace"
                 font-weight="bold"
                 font-size="9.5pt">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>



   <!-- Subscripts -->

   <xsl:template match="subscript">
      <fo:inline vertical-align="sub"
                 font-size="8pt">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- Superscripts -->

   <xsl:template match="superscript">
      <fo:inline vertical-align="super"
                 font-size="8pt">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- User input to the command console   -->

   <xsl:template match="userinput">
      <fo:inline hyphenate="false"
                 font-family="monospace"
                 font-weight="bold"
                 font-size="9.5pt">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- O-O Class names -->
   <!-- O-O property names -->

   <xsl:template match="classname | property | filename | type">
      <fo:inline hyphenate="false"
                 font-family="sans-serif"
                 font-size-adjust="0.46">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- Variables and parameters -->
   <!-- Error messages -->

   <xsl:template match="varname | parameter | errorname">
      <fo:inline hyphenate="false"
                 font-style="italic">
         <xsl:apply-templates/>
      </fo:inline>
   </xsl:template>

   <!-- Higher-level GUI items  -->
   <!-- (no matches at present) -->
   <!-- Lower-level GUI items  -->

   <xsl:template match="guimenu | guisubmenu | guibutton | guilabel | guimenuitem | guiicon | keycap | keycode">
      <fo:wrapper font-family="sans-serif"
                  font-weight="bold"
                  font-size-adjust="0.44">
         <xsl:apply-templates/>
      </fo:wrapper>
   </xsl:template>

   <xsl:template match="interface">
      <fo:wrapper font-family="sans-serif"
                  font-weight="bold"
                  font-size-adjust="0.44">
         <xsl:apply-templates/>
      </fo:wrapper>
   </xsl:template>

   <!-- Synopsis -->

   <xsl:template match="synopsis">
      <fo:block text-align="start"
                keep-with-previous.within-page="always"
                keep-with-next.within-page="always"
                page-break-inside="avoid"
                space-before="6pt"
                space-after="6pt"
                font="9.5pt/1.0 monospace"
                white-space-collapse="false"
                linefeed-treatment="preserve"
                line-stacking-strategy="font-height"
                orphans="3"
                widows="3"
                start-indent="6pt"
                end-indent="6pt"
                padding="6pt"
                background-color="silver">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <!-- Figure -->

   <xsl:template match="figure">
      <xsl:variable name="linkid"
                    select="@label"/>
      <fo:block id="{$linkid}"
                xsl:use-attribute-sets="title-attrs"
                text-align="center">
         <xsl:apply-templates select="title"
                              mode="numbered-text"/>
      </fo:block>
      <xsl:apply-templates select="*[not(self::title)]"/>
   </xsl:template>

   <!-- Graphic -->

   <xsl:template match="graphic">
      <fo:block space-after.optimum="9pt"
                text-align="center">
         <xsl:apply-templates mode="graphic-attribute"/>
         <fo:external-graphic src="url('{@fileref}')">
            <xsl:if test="@width and @depth">
               <xsl:attribute name="scaling">non-uniform</xsl:attribute>
            </xsl:if>
            <xsl:apply-templates select="@scale"
                                 mode="graphic-attribute"/>
            <xsl:apply-templates select="@width"
                                 mode="graphic-attribute"/>
            <xsl:apply-templates select="@depth"
                                 mode="graphic-attribute"/>
            <xsl:apply-templates select="@format"
                                 mode="graphic-attribute"/>
         </fo:external-graphic>
      </fo:block>
   </xsl:template>

   <!-- Inline graphic  -->

   <xsl:template match="inlinegraphic">
      <fo:inline>
         <xsl:apply-templates mode="graphic-attribute"/>
         <fo:external-graphic src="url('{@fileref}')">
            <xsl:if test="@width and @depth">
               <xsl:attribute name="scaling">non-uniform</xsl:attribute>
            </xsl:if>
            <xsl:apply-templates select="@scale"
                                 mode="graphic-attribute"/>
            <xsl:apply-templates select="@width"
                                 mode="graphic-attribute"/>
            <xsl:apply-templates select="@depth"
                                 mode="graphic-attribute"/>
            <xsl:apply-templates select="@format"
                                 mode="graphic-attribute"/>
         </fo:external-graphic>
      </fo:inline>
   </xsl:template>

   <!-- Graphic attribute processing  -->

   <xsl:template match="@align"
                 mode="graphic-attribute">
      <xsl:attribute name="text-align">center</xsl:attribute>
   </xsl:template>

   <xsl:template match="@width"
                 mode="graphic-attribute">
      <xsl:attribute name="content-width">
         <xsl:value-of select="."/>
      </xsl:attribute>
   </xsl:template>

   <xsl:template match="@depth"
                 mode="graphic-attribute">
      <xsl:attribute name="content-height">
         <xsl:value-of select="."/>
      </xsl:attribute>
   </xsl:template>

   <xsl:template match="@scale"
                 mode="graphic-attribute">
      <xsl:attribute name="content-width">
         <xsl:value-of select="."/>
         100%
      </xsl:attribute>
      <xsl:attribute name="content-height">
         <xsl:value-of select="."/>
         100%
      </xsl:attribute>
   </xsl:template>

   <xsl:template match="@format"
                 mode="graphic-attribute">
      <xsl:attribute name="content-type">
         <xsl:choose>
            <xsl:when test=".='GIF'">content-type:image/gif</xsl:when>
            <xsl:when test=".='JPEG'">content-type:image/jpeg</xsl:when>
            <xsl:when test=".='PNG'">content-type:image/png</xsl:when>
            <xsl:when test=".='TIFF'">content-type:image/tiff</xsl:when>
            <xsl:when test=".='BMP'">content-type:image/bmp</xsl:when>
            <xsl:when test=".='SVG'">content-type:image/svg+xml</xsl:when>
            <xsl:when test=".='EPS'">content-type:application/postscript</xsl:when>
            <xsl:when test=".='PDF'">content-type:application/pdf</xsl:when>
            <xsl:otherwise>auto</xsl:otherwise>
         </xsl:choose>
      </xsl:attribute>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Links                                                           -->
   <!-- *************************************************************** --> 

   <!-- External hyperlinks -->
   
   <xsl:template match="ulink">
   
      <xsl:variable name="url"
                    select="@url"/>
                   
      <xsl:choose>
        
         <!-- True external references -->
         
         <xsl:when test="@condition='preserve'">
            <fo:basic-link xsl:use-attribute-sets="href-attrs"
                           external-destination="url('{$url}')">
               <xsl:apply-templates/>
            </fo:basic-link>
         </xsl:when>
        
         <!-- References within the same book -->
         
         <xsl:otherwise>
            <fo:basic-link color="{$href-color}"
                           internal-destination="{$url}">
               <fo:inline hyphenate="false">
                  <xsl:apply-templates/>
               </fo:inline>
            </fo:basic-link>
         </xsl:otherwise>
         
      </xsl:choose>
     
   </xsl:template>

   <!-- Internal links -->
   <!-- Create an xref to the {book|preface|chapter|appendix|glossary|sect1|sect2|sect3|sect4|table|figure|example}  -->
   <!-- whose @id attribute is the same as the value of this element's @linkend attribute  -->

   <xsl:template match="link">
      <xsl:variable name="linkend"
                    select="@linkend"/>
      <fo:basic-link color="{$href-color}"
                     internal-destination="{$linkend}">
         <xsl:apply-templates/>
      </fo:basic-link>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Notes                                                           -->
   <!-- *************************************************************** -->

   <xsl:template match="warning">
      <fo:list-block provisional-label-separation="3pt"
                     provisional-distance-between-starts="76pt"
                     space-before.optimum="9pt"
                     space-after.optimum="6pt"
                     keep-together.within-page="always">
         <fo:list-item>
            <fo:list-item-label end-indent="label-end()">
               <fo:block font-weight="bold"
                         font-size="11.5pt"
                         color="#E10000"
                         text-align="start">
                  <xsl:text>WARNING!</xsl:text>
               </fo:block>
            </fo:list-item-label>
            <fo:list-item-body start-indent="body-start()">
               <fo:block>
                  <xsl:apply-templates/>
               </fo:block>
            </fo:list-item-body>
         </fo:list-item>
      </fo:list-block>
   </xsl:template>

   <xsl:template match="note">
      <fo:list-block hyphenate="false"
                     provisional-label-separation="3pt"
                     provisional-distance-between-starts="38pt"
                     space-before.optimum="9pt"
                     space-after.optimum="6pt"
                     keep-together.within-page="always">
         <fo:list-item>
            <fo:list-item-label end-indent="label-end()">
               <fo:block font-weight="bold"
                         text-align="start">
                  <xsl:text>Note: </xsl:text>
               </fo:block>
            </fo:list-item-label>
            <fo:list-item-body start-indent="body-start()">
               <fo:block>
                  <xsl:apply-templates/>
               </fo:block>
            </fo:list-item-body>
         </fo:list-item>
      </fo:list-block>
   </xsl:template>

   <xsl:template match="tip">
      <fo:list-block hyphenate="false"
                     provisional-label-separation="3pt"
                     provisional-distance-between-starts="32pt"
                     space-before.optimum="9pt"
                     space-after.optimum="6pt"
                     keep-together.within-page="always">
         <fo:list-item>
            <fo:list-item-label end-indent="label-end()">
               <fo:block font-weight="bold"
                         text-align="start">
                  <xsl:text>Tip: </xsl:text>
               </fo:block>
            </fo:list-item-label>
            <fo:list-item-body start-indent="body-start()">
               <fo:block>
                  <xsl:apply-templates/>
               </fo:block>
            </fo:list-item-body>
         </fo:list-item>
      </fo:list-block>
   </xsl:template>

   <xsl:template match="caution">
      <fo:list-block hyphenate="false"
                     provisional-label-separation="3pt"
                     provisional-distance-between-starts="66pt"
                     space-before.optimum="9pt"
                     space-after.optimum="6pt"
                     keep-together.within-page="always">
         <fo:list-item>
            <fo:list-item-label end-indent="label-end()">
               <fo:block font-weight="bold"
                         font-size="10.5pt"
                         text-align="start">
                  <xsl:text>CAUTION:</xsl:text>
               </fo:block>
            </fo:list-item-label>
            <fo:list-item-body start-indent="body-start()">
               <fo:block>
                  <xsl:apply-templates/>
               </fo:block>
            </fo:list-item-body>
         </fo:list-item>
      </fo:list-block>
   </xsl:template>

   <xsl:template match="important">
      <fo:list-block hyphenate="false"
                     provisional-label-separation="3pt"
                     provisional-distance-between-starts="66pt"
                     space-before.optimum="9pt"
                     space-after.optimum="6pt"
                     keep-together.within-page="always">
         <fo:list-item>
            <fo:list-item-label end-indent="label-end()">
               <fo:block font-weight="bold"
                         text-align="start">
                  <xsl:text>Important: </xsl:text>
               </fo:block>
            </fo:list-item-label>
            <fo:list-item-body start-indent="body-start()">
               <fo:block>
                  <xsl:apply-templates/>
               </fo:block>
            </fo:list-item-body>
         </fo:list-item>
      </fo:list-block>
   </xsl:template>

   <!-- =============================================================== -->
   <!-- Lists: ordered and unordered                                    -->
   <!-- =============================================================== -->
   <!-- List-block template: identical processing, different messages.  -->

   <xsl:template match="itemizedlist">

      <xsl:variable name="list-level"
                    select="count(ancestor-or-self::itemizedlist)"/>
      <xsl:variable name="other-level" 
                    select="count(ancestor-or-self::orderedlist)"/>
      <xsl:variable name="total-level" 
                    select="$list-level + $other-level"/>

      <fo:list-block provisional-label-separation="3pt"
                     provisional-distance-between-starts="18pt"
                     space-before.optimum="6pt"
                     space-after.optimum="6pt">
                     
<!--         <xsl:message>Bulleted list level <xsl:value-of select="$list-level"/> contained in <xsl:value-of select="$other-level"/> ordered list level(s) = absolute level <xsl:value-of select="$total-level"/></xsl:message> -->

         <xsl:apply-templates>
            <xsl:with-param name="list-level"
                            select="$list-level"/>
         </xsl:apply-templates>
      </fo:list-block>
   </xsl:template>

   <xsl:template match="orderedlist">
      <xsl:variable name="list-level"
                    select="count(ancestor-or-self::orderedlist)"/>
      <xsl:variable name="other-level" 
                    select="count(ancestor-or-self::itemizedlist)"/>
      <xsl:variable name="total-level" 
                    select="$list-level + $other-level"/>

      <fo:list-block provisional-label-separation="3pt"
                     provisional-distance-between-starts="18pt"
                     space-before.optimum="6pt"
                     space-after.optimum="6pt">
                     
<!--         <xsl:message>Ordered list level <xsl:value-of select="$list-level"/> contained in <xsl:value-of select="$other-level"/> bulleted list level(s) = absolute level <xsl:value-of select="$total-level"/></xsl:message> -->

         <xsl:apply-templates>
            <xsl:with-param name="list-level"
                            select="$list-level"/>
         </xsl:apply-templates>
      </fo:list-block>
   </xsl:template>

   <!-- =============================================================== -->
   <!-- Item for an unordered list                                      -->

   <xsl:template match="itemizedlist/listitem">
      <xsl:param name="list-level"/>
      <fo:list-item>
         <fo:list-item-label end-indent="label-end()">
            <fo:block text-align="start">
               <xsl:choose>
                  <xsl:when test="($list-level mod 2) = 1">
                     <xsl:text>&bull;</xsl:text>

                     <!-- disk bullet -->

                  </xsl:when>
                  <xsl:otherwise>
                     <xsl:text>-</xsl:text>

                     <!-- hyphen bullet -->

                  </xsl:otherwise>
               </xsl:choose>
            </fo:block>
         </fo:list-item-label>
         <fo:list-item-body start-indent="body-start()">
            <fo:block>
               <xsl:apply-templates/>
            </fo:block>
         </fo:list-item-body>
      </fo:list-item>
   </xsl:template>

   <!-- =============================================================== -->
   <!-- Ordered list item                                               -->

   <xsl:template match="orderedlist/listitem">
      <xsl:param name="list-level"/>
      <fo:list-item>
         <fo:list-item-label end-indent="label-end()">
            <fo:block text-align="start">
               <xsl:choose>
                  <xsl:when test="($list-level mod 2) = 1">

                     <!-- arabic -->

                     <xsl:number format="1."/>
                  </xsl:when>
                  <xsl:otherwise>

                     <!-- alphabetic -->

                     <xsl:number format="a."/>
                  </xsl:otherwise>
               </xsl:choose>
            </fo:block>
         </fo:list-item-label>
         <fo:list-item-body start-indent="body-start()">
            <fo:block>
               <xsl:apply-templates/>
            </fo:block>
         </fo:list-item-body>
      </fo:list-item>
   </xsl:template>

   <!-- =============================================================== -->
   <!-- Definition list                                                 -->
   <!-- =============================================================== -->

   <xsl:template match="variablelist">
      <fo:block space-before.optimum="6pt"
                space-after.optimum="6pt">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <xsl:template match="varlistentry">
      <fo:block space-before.optimum="6pt"
                keep-together.within-column="always"
                keep-with-next.within-column="always"
                font-weight="bold"
                line-height="1.1">
         <xsl:for-each select="term">
            <fo:block>
               <xsl:apply-templates/>
            </fo:block>
         </xsl:for-each>
      </fo:block>
      <xsl:apply-templates select="listitem"/>
   </xsl:template>

   <xsl:template match="varlistentry/listitem">
      <fo:block space-before.optimum="3pt"
                start-indent="0.5in">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Tables                                                          -->
   <!-- *************************************************************** -->

   <xsl:template match="table">
      <xsl:variable name="linkid"
                    select="@label"/>
      <fo:block id="{$linkid}"
                xsl:use-attribute-sets="title-attrs"
                text-align="center">
         <xsl:attribute name="page-break-before">
            <xsl:choose>
               <xsl:when test="@tabstyle='keep'">auto</xsl:when>
               <xsl:when test="@tabstyle='break'">auto</xsl:when>
               <xsl:when test="@tabstyle='top'">always</xsl:when>
               <xsl:otherwise>auto</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:attribute name="space-before.optimum">
            <xsl:choose>
               <xsl:when test="@tabstyle='keep'">6pt</xsl:when>
               <xsl:when test="@tabstyle='break'">6pt</xsl:when>
               <xsl:when test="@tabstyle='top'">36pt</xsl:when>
               <xsl:otherwise>6pt</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:apply-templates select="title"
                              mode="numbered-text"/>
      </fo:block>
      <xsl:apply-templates select="*[not(self::title)]"/>
   </xsl:template>

   <xsl:template match="informaltable">
      <xsl:apply-templates/>
   </xsl:template>

   <xsl:template match="table/title">
      <fo:block xsl:use-attribute-sets="title-attrs"
                text-align="center">
         <xsl:apply-templates select="."
                              mode="numbered-text"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="tgroup">
      <fo:table border-bottom="thin solid #A0A0A0"
                border-top="thin solid #A0A0A0"
                border-left="thin solid #A0A0A0"
                border-right="thin solid #A0A0A0">
         <xsl:attribute name="page-break-before">
            <xsl:choose>
               <xsl:when test="ancestor::informaltable/@tabstyle='keep'">auto</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='break'">auto</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='top'">always</xsl:when>
               <xsl:otherwise>auto</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:attribute name="space-after.optimum">
            <xsl:choose>
               <xsl:when test="ancestor::table/@tabstyle='keep'">15pt</xsl:when>
               <xsl:when test="ancestor::table/@tabstyle='break'">4pt</xsl:when>
               <xsl:when test="ancestor::table/@tabstyle='top'">4pt</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='keep'">15pt</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='break'">4pt</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='top'">4pt</xsl:when>
               <xsl:otherwise>15pt</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:apply-templates select="@align"/>
         <xsl:apply-templates select="colspec"/>
         <xsl:apply-templates select="thead"/>
         <xsl:apply-templates select="tfoot"/>
         <xsl:apply-templates select="tbody"/>
      </fo:table>
   </xsl:template>

   <xsl:template match="colspec">
      <fo:table-column>
         <xsl:apply-templates select="@colwidth|@align"/>
      </fo:table-column>
   </xsl:template>

   <xsl:template match="thead">
      <fo:table-header background-color="#A0A0A0"
                       font-size="10pt"
                       font-weight="bold"
                       font-family="sans-serif"
                       page-break-inside="avoid"
                       keep-with-next.within-page="always"
                       text-align="start">
         <xsl:apply-templates select="@valign"/>
         <xsl:apply-templates/>
      </fo:table-header>
   </xsl:template>

   <xsl:template match="tfoot">
      <fo:table-footer background-color="#A0A0A0"
                       font-size="11pt"
                       font-weight="bold"
                       font-family="sans-serif"
                       page-break-inside="avoid"
                       keep-with-previous.within-page="always">
         <xsl:apply-templates select="@valign"/>
         <xsl:apply-templates/>
      </fo:table-footer>
   </xsl:template>

   <xsl:template match="tbody">
      <fo:table-body>
         <xsl:attribute name="page-break-inside">
            <xsl:choose>
               <xsl:when test="ancestor::table/@tabstyle='keep'">avoid</xsl:when>
               <xsl:when test="ancestor::table/@tabstyle='break'">auto</xsl:when>
               <xsl:when test="ancestor::table/@tabstyle='top'">auto</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='keep'">avoid</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='break'">auto</xsl:when>
               <xsl:when test="ancestor::informaltable/@tabstyle='top'">auto</xsl:when>
               <xsl:otherwise>avoid</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:apply-templates select="@valign"/>
         <xsl:apply-templates/>
      </fo:table-body>
   </xsl:template>

   <xsl:template match="row">
      <fo:table-row font-size="10pt"
                    font-family="sans-serif"
                    page-break-inside="avoid">
         <xsl:apply-templates select="@valign"/>
         <xsl:apply-templates/>
      </fo:table-row>
   </xsl:template>

   <xsl:template match="entry"
                 priority="1">
      <fo:table-cell font-size="10pt"
                     font-family="sans-serif"
                     page-break-inside="avoid"
                     border-before-width.conditionality="retain"
                     border-after-width.conditionality="retain"
                     padding-top="3pt"
                     padding-bottom="3pt"
                     padding-left="6pt"
                     padding-right="6pt"
                     start-indent="0"
                     text-align="start">
         <xsl:apply-templates select="@align|@valign|@morerows"/>
         <xsl:choose>
            <xsl:when test="@namest">
               <xsl:variable name="start-column">
                  <xsl:call-template name="col-number-by-name">
                     <xsl:with-param name="colname"
                                     select="@namest"/>
                  </xsl:call-template>
               </xsl:variable>
               <xsl:attribute name="column-number">
                  <xsl:value-of select="$start-column"/>
               </xsl:attribute>
               <xsl:if test="@nameend">
                  <xsl:variable name="end-column">
                     <xsl:call-template name="col-number-by-name">
                        <xsl:with-param name="colname"
                                        select="@nameend"/>
                     </xsl:call-template>
                  </xsl:variable>
                  <xsl:attribute name="number-columns-spanned">
                     <xsl:value-of select="$end-column - $start-column + 1"/>
                  </xsl:attribute>
               </xsl:if>
            </xsl:when>
            <xsl:when test="@colname">
               <xsl:variable name="start-column">
                  <xsl:call-template name="col-number-by-name">
                     <xsl:with-param name="colname"
                                     select="@colname"/>
                  </xsl:call-template>
               </xsl:variable>
               <xsl:attribute name="column-number">
                  <xsl:value-of select="$start-column"/>
               </xsl:attribute>
            </xsl:when>
         </xsl:choose>
         <fo:block>
            <xsl:apply-templates/>
         </fo:block>
      </fo:table-cell>
   </xsl:template>

   <xsl:template match="informaltable[@frame='all']//entry | table[@frame='all']//entry"
                 priority="2">
      <fo:table-cell font-size="10pt"
                     font-family="sans-serif"
                     page-break-inside="avoid"
                     border-before-width.conditionality="retain"
                     border-after-width.conditionality="retain"
                     padding-top="3pt"
                     padding-bottom="3pt"
                     padding-left="6pt"
                     padding-right="6pt"
                     start-indent="0"
                     text-align="start"
                     border-bottom="thin solid #A0A0A0"
                     border-top="thin solid #A0A0A0"
                     border-left="thin solid #A0A0A0"
                     border-right="thin solid #A0A0A0">
         <xsl:apply-templates select="@align|@valign|@morerows"/>
         <xsl:choose>
            <xsl:when test="@namest">
               <xsl:variable name="start-column">
                  <xsl:call-template name="col-number-by-name">
                     <xsl:with-param name="colname"
                                     select="@namest"/>
                  </xsl:call-template>
               </xsl:variable>
               <xsl:attribute name="column-number">
                  <xsl:value-of select="$start-column"/>
               </xsl:attribute>
               <xsl:if test="@nameend">
                  <xsl:variable name="end-column">
                     <xsl:call-template name="col-number-by-name">
                        <xsl:with-param name="colname"
                                        select="@nameend"/>
                     </xsl:call-template>
                  </xsl:variable>
                  <xsl:attribute name="number-columns-spanned">
                     <xsl:value-of select="$end-column - $start-column + 1"/>
                  </xsl:attribute>
               </xsl:if>
            </xsl:when>
            <xsl:when test="@colname">
               <xsl:variable name="start-column">
                  <xsl:call-template name="col-number-by-name">
                     <xsl:with-param name="colname"
                                     select="@colname"/>
                  </xsl:call-template>
               </xsl:variable>
               <xsl:attribute name="column-number">
                  <xsl:value-of select="$start-column"/>
               </xsl:attribute>
            </xsl:when>
         </xsl:choose>
         <fo:block>
            <xsl:apply-templates/>
         </fo:block>
      </fo:table-cell>
   </xsl:template>

   <xsl:template name="col-number-by-name">
      <xsl:param name="colname"/>
      <xsl:call-template name="col-number-by-name-recursive">
         <xsl:with-param name="csp"
                         select="ancestor::tgroup[1]/colspec[@colname=$colname]"/>
      </xsl:call-template>
   </xsl:template>

   <xsl:template name="col-number-by-name-recursive">
      <xsl:param name="csp"/>
      <xsl:choose>
         <xsl:when test="not($csp)">0</xsl:when>
         <xsl:otherwise>
            <xsl:variable name="prevnum">
               <xsl:call-template name="col-number-by-name-recursive">
                  <xsl:with-param name="csp"
                                  select="$csp/preceding-sibling::colspec"/>
               </xsl:call-template>
            </xsl:variable>
            <xsl:value-of select="$prevnum + 1"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match="@colwidth">
      <xsl:attribute name="column-width">
         <xsl:value-of select="."/>
      </xsl:attribute>
   </xsl:template>

   <xsl:template match="@align">
      <xsl:attribute name="text-align">
         <xsl:value-of select="."/>
      </xsl:attribute>
   </xsl:template>

   <xsl:template match="@valign">
      <xsl:attribute name="display-align">
         <xsl:choose>
            <xsl:when test=".='top'">before</xsl:when>
            <xsl:when test=".='middle'">center</xsl:when>
            <xsl:when test=".='bottom'">after</xsl:when>
            <xsl:otherwise>inherit</xsl:otherwise>
         </xsl:choose>
      </xsl:attribute>
   </xsl:template>

   <xsl:template match="@morerows">
      <xsl:attribute name="number-rows-spanned">
         <xsl:value-of select=". + 1"/>
      </xsl:attribute>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Commented code examples                                         -->
   <!-- *************************************************************** -->

   <xsl:template match="example | informalexample">
      <fo:block>
         <xsl:apply-templates select="title"/>
         <xsl:apply-templates select="para"/>
         <xsl:apply-templates select="programlisting"/>
         <xsl:apply-templates select="calloutlist"/>
      </fo:block>
   </xsl:template>

   <xsl:template match="programlisting">
      <fo:block text-align="start"
                space-before="9pt"
                space-after="12pt"
                font="8.3pt/1.0 monospace"
                white-space-collapse="false"
                white-space-treatment="preserve"
                hyphenate="false"
                linefeed-treatment="preserve"
                page-break-inside="avoid"
                line-stacking-strategy="font-height"
                orphans="3"
                widows="3">
         <xsl:attribute name="start-indent">
            <xsl:choose>
               <xsl:when test="count(ancestor::listitem) = 1">18pt</xsl:when>
               <xsl:when test="count(ancestor::listitem) = 2">36pt</xsl:when>
               <xsl:when test="count(ancestor::listitem) = 3">54pt</xsl:when>
               <xsl:when test="count(ancestor::question) = 1">6pt</xsl:when>
               <xsl:when test="count(ancestor::glossdef) = 1">36pt</xsl:when>
               <xsl:when test="count(ancestor::note) = 1">38pt</xsl:when>
               <xsl:otherwise>0pt</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:attribute name="font-size">
            <xsl:choose>
               <xsl:when test="count(ancestor::listitem) = 1">8pt</xsl:when>
               <xsl:when test="count(ancestor::listitem) = 2">7.6pt</xsl:when>
               <xsl:when test="count(ancestor::listitem) = 3">7.2pt</xsl:when>
               <xsl:when test="count(ancestor::question) = 1">8pt</xsl:when>
               <xsl:when test="count(ancestor::glossdef) = 1">7.6pt</xsl:when>
               <xsl:when test="count(ancestor::note) = 1">7.6pt</xsl:when>
               <xsl:otherwise>8.3pt</xsl:otherwise>
            </xsl:choose>
         </xsl:attribute>
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <xsl:template match="literallayout">
      <xsl:variable name="fontchoice"
                    select="@class"/>
      <fo:block text-align="start"
                space-before="9pt"
                space-after="12pt"
                white-space-collapse="false"
                white-space-treatment="preserve"
                hyphenate="false"
                linefeed-treatment="preserve"
                page-break-inside="avoid"
                line-stacking-strategy="font-height"
                orphans="3"
                widows="3">
         <xsl:choose>
            <xsl:when test="$fontchoice='monospaced'">
               <xsl:attribute name="font">
                  <xsl:choose>
                     <xsl:when test="count(ancestor::listitem) = 1">8pt/1.0 monospace</xsl:when>
                     <xsl:when test="count(ancestor::listitem) = 2">7.6pt/1.0 monospace</xsl:when>
                     <xsl:when test="count(ancestor::listitem) = 3">7.2pt/1.0 monospace</xsl:when>
                     <xsl:when test="count(ancestor::question) = 1">8pt/1.0 monospace</xsl:when>
                     <xsl:when test="count(ancestor::glossdef) = 1">7.6pt/1.0 monospace</xsl:when>
                     <xsl:when test="count(ancestor::note) = 1">7.6pt/1.0 monospace</xsl:when>
                     <xsl:otherwise>8.3pt/1.0 monospace</xsl:otherwise>
                  </xsl:choose>
               </xsl:attribute>
               <xsl:attribute name="start-indent">
                  <xsl:choose>
                     <xsl:when test="count(ancestor::listitem) = 1">18pt</xsl:when>
                     <xsl:when test="count(ancestor::listitem) = 2">36pt</xsl:when>
                     <xsl:when test="count(ancestor::listitem) = 3">54pt</xsl:when>
                     <xsl:when test="count(ancestor::question) = 1">6pt</xsl:when>
                     <xsl:when test="count(ancestor::glossdef) = 1">36pt</xsl:when>
                     <xsl:when test="count(ancestor::note) = 1">38pt</xsl:when>
                     <xsl:otherwise>0pt</xsl:otherwise>
                  </xsl:choose>
               </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
               <xsl:attribute name="font">
                  <xsl:choose>
                     <xsl:when test="count(ancestor::listitem) = 1">7.6pt/1.0 sans-serif</xsl:when>
                     <xsl:when test="count(ancestor::listitem) = 2">7.2pt/1.0 sans-serif</xsl:when>
                     <xsl:when test="count(ancestor::listitem) = 3">6.8pt/1.0 sans-serif</xsl:when>
                     <xsl:when test="count(ancestor::question) = 1">7.6pt/1.0 sans-serif</xsl:when>
                     <xsl:when test="count(ancestor::glossdef) = 1">7.2pt/1.0 sans-serif</xsl:when>
                     <xsl:when test="count(ancestor::note) = 1">7.2pt/1.0 sans-serif</xsl:when>
                     <xsl:otherwise>8pt/1.0 sans-serif</xsl:otherwise>
                  </xsl:choose>
               </xsl:attribute>
               <xsl:attribute name="font-stretch">semi-condensed</xsl:attribute>
            </xsl:otherwise>
         </xsl:choose>
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <xsl:template match="example/programlisting | informalexample/programlisting"
                 priority="2">
      <fo:block text-align="start"
                space-before="9pt"
                space-after="12pt"
                font="8pt/1.0 monospace"
                white-space-collapse="false"
                white-space-treatment="preserve"
                hyphenate="false"
                linefeed-treatment="preserve"
                page-break-inside="avoid"
                line-stacking-strategy="font-height"
                orphans="3"
                widows="3">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <xsl:template match="co">
      <xsl:variable name="pos">
         <xsl:number count="co"
                     from="programlisting"
                     format="1"
                     level="any"/>
      </xsl:variable>
      <xsl:choose>
         <xsl:when test="$callout.dingbats = 'true'">
            <xsl:call-template name="dingbat-callout-bug">
               <xsl:with-param name="pos"
                               select="$pos"/>
            </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
            <xsl:call-template name="default-callout-bug">
               <xsl:with-param name="pos"
                               select="$pos"/>
            </xsl:call-template>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match="calloutlist">
      <fo:list-block provisional-distance-between-starts="24pt"
                     provisional-label-separation="0pt">
         <xsl:apply-templates select="callout"/>
      </fo:list-block>
   </xsl:template>

   <xsl:template match="callout">
      <fo:list-item>
         <fo:list-item-label end-indent="label-end()">
            <fo:block text-align="center">
               <xsl:variable name="ids"
                             select="concat (' ', @arearefs, ' ')"/>
               <xsl:apply-templates select="ancestor::informalexample/programlisting/co [contains ($ids, concat (' ', @id, ' '))]"/>
            </fo:block>
         </fo:list-item-label>
         <fo:list-item-body start-indent="body-start()">
            <fo:block>
               <xsl:apply-templates/>
            </fo:block>
         </fo:list-item-body>
      </fo:list-item>
   </xsl:template>

   <xsl:template name="default-callout-bug">
      <xsl:param name="pos"/>
      <fo:inline background-color="#404040"
                 color="white"
                 padding-top="0.05em"
                 padding-bottom="0.05em"
                 padding-start="0.15em"
                 padding-end="0.15em"
                 baseline-shift="0.1em"
                 font="bold 70% serif"
                 white-space-treatment="ignore">
         <xsl:value-of select="$pos"/>
      </fo:inline>
   </xsl:template>

   <xsl:template name="dingbat-callout-bug">
      <xsl:param name="pos"/>
      <fo:inline font-family="ZapfDingbats">
         <xsl:choose>
            <xsl:when test="$pos=1">&#x2776;</xsl:when>
            <xsl:when test="$pos=2">&#x2777;</xsl:when>
            <xsl:when test="$pos=3">&#x2778;</xsl:when>
            <xsl:when test="$pos=4">&#x2779;</xsl:when>
            <xsl:when test="$pos=5">&#x277A;</xsl:when>
            <xsl:when test="$pos=6">&#x277B;</xsl:when>
            <xsl:when test="$pos=7">&#x277C;</xsl:when>
            <xsl:when test="$pos=8">&#x277D;</xsl:when>
            <xsl:when test="$pos=9">&#x277E;</xsl:when>
            <xsl:when test="$pos=10">&#x277F;</xsl:when>
            <xsl:otherwise>

               <!-- overflow -->

               <xsl:attribute name="color">red</xsl:attribute>
               <xsl:text>&#x25CF;</xsl:text>
               <xsl:message>
                  <xsl:text>A callout list contains more than 10 callouts;</xsl:text>
                  <xsl:text> callout numbering truncated.</xsl:text>
               </xsl:message>
            </xsl:otherwise>
         </xsl:choose>
      </fo:inline>
   </xsl:template>

   <!-- =============================================================== -->
   <!-- Footnote and FootnoteRef                                        -->
   <!-- =============================================================== -->

   <xsl:template match="footnote">
      <fo:footnote>
         <xsl:apply-templates select="."
                              mode="footnote-number"/>
         <fo:footnote-body font="10pt serif"
                           text-align="start"
                           baseline-shift="0pt"
                           start-indent="0pt"
                           end-indent="0pt"
                           color="black">
            <fo:list-block provisional-distance-between-starts="15pt"
                           provisional-label-separation="0pt">
               <fo:list-item>
                  <fo:list-item-label end-indent="label-end()">
                     <fo:block text-align="start">
                        <xsl:apply-templates select="."
                                             mode="footnote-number"/>
                     </fo:block>
                  </fo:list-item-label>
                  <fo:list-item-body start-indent="body-start()">
                     <fo:block padding-top="2pt">
                        <xsl:apply-templates/>
                     </fo:block>
                  </fo:list-item-body>
               </fo:list-item>
            </fo:list-block>
         </fo:footnote-body>
      </fo:footnote>
   </xsl:template>

   <xsl:template match="footnoteref">
      <xsl:variable name="linkend"
                    select="@linkend"/>
      <xsl:apply-templates select="/descendant::footnote[@id=$linkend]"
                           mode="footnote-number"/>
   </xsl:template>

   <xsl:template match="footnote"
                 mode="footnote-number">
      <fo:inline baseline-shift="super"
                 font-size="75%"
                 white-space-treatment="ignore">
         <xsl:number count="footnote"
                     level="any"
                     format="1"/>
      </fo:inline>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Book Body                                                       -->
   <!-- *************************************************************** -->

   <xsl:template name="book-body">
      <xsl:apply-templates select="preface | chapter | appendix | glossary | reference"/>

      <!--      <xsl:if test="not(//indexterm)"> -->
      <!--        <fo:block id="terminator"/> -->
      <!--      </xsl:if> -->

   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Questions and Answers                                           -->
   <!-- *************************************************************** -->

   <xsl:template match="qandaentry">
      <fo:block>
         <fo:block page-break-inside="avoid"
                   space-before="12pt"
                   space-after="6pt"
                   orphans="3"
                   widows="3"
                   font-weight="bold"
                   start-indent="6pt"
                   end-indent="6pt"
                   keep-with-next.within-page="always"
                   padding="6pt"
                   background-color="silver">
            <xsl:apply-templates select="question"/>
         </fo:block>
         <fo:block>
            <xsl:apply-templates select="answer"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <!-- The following code enables internal cross-refs to those questions that have ids. -->

   <xsl:template match="question">
      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <xsl:apply-templates/>
      </fo:block>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Glossary term definitions                                       -->
   <!-- *************************************************************** -->

   <xsl:template match="glossentry">

      <!-- The following code enables internal cross-refs to those glossterms that have ids. -->

      <xsl:variable name="linkid"
                    select="@id"/>
      <fo:block id="{$linkid}">
         <xsl:if test="ancestor::glossary">
            <fo:marker marker-class-name="topofrightpageheader">
               <fo:wrapper xsl:use-attribute-sets="header-attrs">
                  <xsl:apply-templates select="glossterm"
                                       mode="header"/>
               </fo:wrapper>
            </fo:marker>
         </xsl:if>
         <fo:block space-before="12pt"
                   space-after="6pt"
                   font-weight="bold"
                   font-family="sans-serif"
                   font-size="10pt"
                   keep-with-next.within-page="always">
            <xsl:apply-templates select="glossterm"/>
         </fo:block>
         <fo:block widows="3"
                   orphans="3"
                   margin-left="36pt">
            <xsl:apply-templates select="glossdef"/>
         </fo:block>
      </fo:block>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Book/article Table of Contents                                  -->
   <!-- *************************************************************** -->

   <xsl:template name="book-toc">
      <fo:page-sequence master-reference="TOC"
                        initial-page-number="auto"
                        format="i"
                        force-page-count="auto"
                        id="TOCchapters">
         <fo:static-content flow-name="left-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="42pt 0.9in 0.2in 0.5in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <fo:page-number/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                     <xsl:if test="ancestor-or-self::book">
                        <xsl:value-of select="$opus"/>
                     </xsl:if>
                     <xsl:if test="ancestor-or-self::article">
                        <xsl:value-of select="$junior"/>
                     </xsl:if>
                  </fo:inline>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="42pt 0.5in 0.2in 0.9in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <xsl:if test="ancestor-or-self::book">
                     <xsl:value-of select="$opus"/>
                  </xsl:if>
                  <xsl:if test="ancestor-or-self::article">
                     <xsl:value-of select="$junior"/>
                  </xsl:if>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                  </fo:inline>
                  <fo:page-number/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body"
                  font="11pt/1.3 serif"
                  text-align="justify">
            <xsl:variable name="linkid"
                          select="$bookid"/>
            <fo:block page-break-before="always"
                      xsl:use-attribute-sets="preface-title-attrs"
                      id="{$linkid}"> Table of Contents </fo:block>
            <xsl:if test="ancestor-or-self::article">
               <fo:block space-before.optimum="6pt"
                         space-after.optimum="2pt"
                         text-align-last="justify"
                         font-weight="bold">
                  <fo:basic-link internal-destination="article-start"
                                 color="{$href-color}">
                     <xsl:value-of select="$junior"/>
                  </fo:basic-link>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="dots"/>
                     <xsl:text>
                     </xsl:text>
                     <fo:page-number-citation ref-id="article-start"/>
                  </fo:inline>
               </fo:block>
            </xsl:if>
            <fo:block>
               <xsl:apply-templates mode="toc"/>
               <xsl:if test="//indexterm">
                  <fo:block space-before.optimum="6pt"
                            space-after.optimum="2pt"
                            text-align-last="justify"
                            font-weight="bold">
                     <fo:basic-link internal-destination="INDEX"
                                    color="{$href-color}"> Index </fo:basic-link>
                     <fo:inline keep-together.within-line="always">
                        <fo:leader leader-pattern="dots"/>
                        <xsl:text>
                        </xsl:text>
                        <fo:page-number-citation ref-id="INDEX"/>
                     </fo:inline>
                  </fo:block>
               </xsl:if>
               <xsl:apply-templates select="lot"
                                    mode="lot"/>
            </fo:block>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- PDF Bookmarks                                                   -->
   <!-- *************************************************************** -->

   <xsl:template name="outline">
      <rx:outline>
         <rx:bookmark internal-destination="TOCchapters">
            <rx:bookmark-label>Table of Contents</rx:bookmark-label>
         </rx:bookmark>
         <xsl:apply-templates mode="bookmark"/>
         <xsl:if test="//indexterm">
            <rx:bookmark internal-destination="INDEX">
               <rx:bookmark-label>Index</rx:bookmark-label>
            </rx:bookmark>
         </xsl:if>
      </rx:outline>
   </xsl:template>

   <!-- *************************************************************** -->
   <!-- Book/article Index                                              -->
   <!-- *************************************************************** -->

   <xsl:template name="book-index">
      <fo:page-sequence master-reference="index-pages"
                        initial-page-number="auto"
                        format="1"
                        force-page-count="end-on-even"
                        id="INDEX">
         <fo:static-content flow-name="left-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="42pt 0.9in 0.2in 0.5in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <fo:page-number/>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                     <xsl:if test="ancestor-or-self::book">
                        <xsl:value-of select="$opus"/>
                     </xsl:if>
                     <xsl:if test="ancestor-or-self::article">
                        <xsl:value-of select="$junior"/>
                     </xsl:if>
                  </fo:inline>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:static-content flow-name="right-footer">
            <fo:block text-align="start"
                      text-align-last="justify"
                      xsl:use-attribute-sets="header-attrs"
                      padding="42pt 0.5in 0.2in 0.9in"
                      margin="0pt">
               <fo:block border-top="thin solid #808080"
                         padding-top="1pt">
                  <xsl:if test="ancestor-or-self::book">
                     <xsl:value-of select="$opus"/>
                  </xsl:if>
                  <xsl:if test="ancestor-or-self::article">
                     <xsl:value-of select="$junior"/>
                  </xsl:if>
                  <fo:inline keep-together.within-line="always">
                     <fo:leader leader-pattern="use-content">&nbsp;</fo:leader>
                     <xsl:text>
                     </xsl:text>
                  </fo:inline>
                  <fo:page-number/>
               </fo:block>
            </fo:block>
         </fo:static-content>
         <fo:flow flow-name="xsl-region-body"
                  font="11pt/1.3 serif"
                  text-align="justify">
            <xsl:call-template name="generate-index"/>
            <fo:block id="terminator"/>
         </fo:flow>
      </fo:page-sequence>
   </xsl:template>
</xsl:stylesheet>
