#ifndef CPPBIND_CACHE_ANT_H
#define CPPBIND_CACHE_ANT_H

#include "cache.h"

class Cache_ant : public Cache {
private:
   Cache_map cache_map;
   Unset_props unset_props;
   Close_queue close_queue;

public:
   Cache_ant(Database* db);

   Cache_type get_type()
      { return ANT; }
   void remove(int oref)
      { cache_map.remove(oref); }

   void get(t_istream& in)
      {
         int oref, num_orefs;
         in >> num_orefs;
         for (int ii = 0; ii < num_orefs; ++ii)
         {
            in >> oref;
            cache_map.insert(oref, in); // read next $zobjval
         }
      }
   void put(t_ostream& out)
      {
         unset_props.put(out, this);
         close_queue.put(out);
      }
   bool get_property(int oref,
                     int ii,
                     int jj,
                     bool is_obj,
                     t_istrstream& in);
   bool set_property(int oref,
                     int ii,
                     int jj,
                     int mod_flag,
                     bool is_obj,
                     const_name_t name,
                     D_type* val);
   void enqueue_close(int oref)
      { close_queue.enqueue(oref); }
};

#endif
