#ifndef CPPBIND_CLIENT_OBJS_H
#define CPPBIND_CLIENT_OBJS_H

#include "dyn_obj.h"

//==============

class d_sql_proc_context : protected Dyn_obj {
   friend class d_ref<d_sql_proc_context>;

protected:
   d_sql_proc_context() {}

   d_sql_proc_context(Database* db, int ref, const_name_t tname)
      : Dyn_obj(db, ref, tname)
      {}

public:
   Database* get_db()
      { return Dyn_obj::get_db(); }
   int get_ref()
      { return Dyn_obj::get_ref(); }

   static d_ref<d_sql_proc_context> openref(Database* db, int ref, const_name_t tname = 0)
      {
         Obj_t* obj; int* num_refs;
         if (db->get_proxies_info()->get_proxy_info(ref,
                                                    typeid(d_sql_proc_context),
                                                    &obj, &num_refs))
            return d_ref<d_sql_proc_context>(dynamic_cast<d_sql_proc_context*>(obj),
                                             num_refs);
         else
            return d_ref<d_sql_proc_context>(new d_sql_proc_context(db,
                                                                    ref,
                                                                    t_SQLProcContext));
      }

   static d_ref<d_sql_proc_context> create_new(Database* db)
      { return openref(db, d_int(db->make_obj(t_SQLProcContext))); }

   int get_row_count()
      { return d_int(get_property(p_RowCount)); }
   int get_sql_code()
      { return d_int(get_property(p_SQLCode)); }
};

#endif
