#ifndef CPPBIND_ERRORS_H
#define CPPBIND_ERRORS_H

#include "abs_types.h"
#include "t_iostream.h"

//==============

class Err_close_obj : public Db_err {
private:
   int oref;
   int num_refs;

public:
   Err_close_obj(const Db_err& err)
      : Db_err(err)
      {
         t_istrstream in(data.get_buf(), data.get_size());
         in >> oref >> num_refs;
      }
};

//==============

typedef enum {EXCL_LOCK_ERR = 5803,
              READ_LOCK_ERR = 5804,
              NOT_FOUND_ERR = 5809}
open_obj_err_t;

class Err_open_obj : public Db_err {
private:
   int status;

public:
   Err_open_obj(const Db_err& err);
};

#endif
