#ifndef CPPBIND_ODBC_COMMON_H
#define CPPBIND_ODBC_COMMON_H

#include <sql.h>
#include <sqlext.h>
#include <sqlucode.h>

inline bool is_sql_double(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_FLOAT ||
      sql_type == SQL_DOUBLE;
}
inline bool is_sql_int(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_SMALLINT ||
      sql_type == SQL_INTEGER ||
      sql_type == SQL_TINYINT ||
      sql_type == SQL_BIGINT;
}

inline bool is_sql_n_str(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_CHAR ||
      sql_type == SQL_VARCHAR ||
      sql_type == SQL_LONGVARCHAR;
}

inline bool is_sql_w_str(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_WCHAR ||
      sql_type == SQL_WVARCHAR ||
      sql_type == SQL_WLONGVARCHAR;
}

inline bool is_sql_str(SQLSMALLINT sql_type)
{ return is_sql_n_str(sql_type) || is_sql_w_str(sql_type); }

inline bool is_sql_bin(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_BINARY ||
      sql_type == SQL_VARBINARY ||
      sql_type == SQL_LONGVARBINARY;
}

inline bool is_sql_date(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_TYPE_DATE ||
      sql_type == SQL_DATE;
}
inline bool is_sql_time(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_TYPE_TIME ||
      sql_type == SQL_TIME;
}
inline bool is_sql_timestamp(SQLSMALLINT sql_type)
{
   return
      sql_type == SQL_TYPE_TIMESTAMP ||
      sql_type == SQL_TIMESTAMP;
}

#endif
