#ifndef CPPBIND_ZF_FUNCS_H
#define CPPBIND_ZF_FUNCS_h

#ifndef ZF_DLL
#define ZF_DLL
#endif
#include <cdzf.h>

typedef void* err_handle;
typedef void* conn_handle;

#if defined(__cplusplus)
extern "C" {
#endif


/* Db_err interface */

int cppbind_alloc_err(err_handle* err);
int cppbind_free_err(err_handle err);

/* Connection Intefrace */

int cppbind_connect(const char* conn_buf,
                             int conn_buf_size,
                             const char* user_buf,
                             int user_buf_size,
                             const char* pwd_buf,
                             int pwd_buf_size,
                             conn_handle* conn,
                             err_handle err);

int cppbind_disconnect(conn_handle conn);

int cppbind_is_connected(conn_handle conn);
int cppbind_is_busy(conn_handle conn);

/* Database interface */

int test(ZARRAYP in, ZARRAYP out);

#ifdef __cplusplus
}
#endif

#endif
