#ifndef __Sample_Address
#define __Sample_Address

#include <cppbind.h>


class Sample_Address : public Embedded_t {
   friend class d_ref<Sample_Address>;
public:

   // Constructors
protected:
   Sample_Address() {}

private:
   Sample_Address(Database* db, int oref) {
      static wchar_t cl_cache_name[] = {83, 97, 109, 112, 108, 101, 46, 65, 100, 100, 114, 101, 115, 115, 0};
      init_openref(db, oref);
   }

public:
   virtual ~Sample_Address() {}

   // Static methods for instantiating classes
   static d_ref<Sample_Address> openref(t_istream& in, Database* db) {
      int oref; const_name_t tname;
      abs_d_ref::get_oref_n_name(in, &oref, &tname);
      return openref(db, oref, tname);
   }
   static d_ref<Sample_Address> openref(Database* db, int oref, const_name_t tname = 0) {
      if (oref == 0)
         return d_ref<Sample_Address>();
      
      Obj_t *obj; int *num_refs;
      if (db->get_proxies_info()->get_proxy_info(oref, typeid(Sample_Address), &obj, &num_refs)) {
         return d_ref<Sample_Address>(dynamic_cast<Sample_Address*>(obj), num_refs);
      } else {
         return d_ref<Sample_Address>(new Sample_Address(db, oref));
      }
   }
   static d_ref<Sample_Address> create_new(Database* db, const_str_t init_val = 0, Db_err* err = 0) {
      static wchar_t cl_cache_name[] = {83, 97, 109, 112, 108, 101, 46, 65, 100, 100, 114, 101, 115, 115, 0};
      return openref(db, d_int(db->make_obj(cl_cache_name, init_val, err)));
   }
   static d_ref<Sample_Address> open(Database* db, const d_binary& id, int concurrency = -1, int timeout = -1, Db_err* err = 0) {
      return openref(db, d_int(db->open_obj(id, concurrency, timeout, err)));
   }


   // set/get methods

   virtual d_string getCity() const;
   virtual void setCity(const d_string&);
   virtual d_string getState() const;
   virtual void setState(const d_string&);
   virtual d_string getStreet() const;
   virtual void setStreet(const d_string&);
   virtual d_string getZip() const;
   virtual void setZip(const d_string&);

   // other methods

   static d_string LogicalToOdbc(Database *__db);
   static d_string LogicalToOdbc(Database *__db, const d_string& val);
   // val ""
   static d_string OdbcToLogical(Database *__db);
   static d_string OdbcToLogical(Database *__db, const d_string& val);
   // val ""
   virtual d_status OnPopulate();
   static d_int Populate(Database *__db);
   static d_int Populate(Database *__db, const d_int& count);
   static d_int Populate(Database *__db, const d_int& count, const d_int& verbose);
   static d_int Populate(Database *__db, const d_int& count, const d_int& verbose, const d_int& DeferIndices);
   static d_int Populate(Database *__db, const d_int& count, const d_int& verbose, const d_int& DeferIndices, d_int& objects);
   // count 10
   // verbose 0
   // DeferIndices 1
   // objects 0
   static d_string PopulateSerial(Database *__db);
};
inline d_string Sample_Address::getCity() const {
   static wchar_t prop_cache_name[] = {67, 105, 116, 121, 0};
   return d_string(get_db()->get_property(get_ref(), 2, 0, LIT_T, prop_cache_name));
}
inline void Sample_Address::setCity(const d_string& City) {
   static wchar_t prop_cache_name[] = {67, 105, 116, 121, 0};
   get_db()->set_property(get_ref(), 2, 0, 2,LIT_T, prop_cache_name, const_cast <d_string*>(&City));
}

inline d_string Sample_Address::getState() const {
   static wchar_t prop_cache_name[] = {83, 116, 97, 116, 101, 0};
   return d_string(get_db()->get_property(get_ref(), 3, 0, LIT_T, prop_cache_name));
}
inline void Sample_Address::setState(const d_string& State) {
   static wchar_t prop_cache_name[] = {83, 116, 97, 116, 101, 0};
   get_db()->set_property(get_ref(), 3, 0, 3,LIT_T, prop_cache_name, const_cast <d_string*>(&State));
}

inline d_string Sample_Address::getStreet() const {
   static wchar_t prop_cache_name[] = {83, 116, 114, 101, 101, 116, 0};
   return d_string(get_db()->get_property(get_ref(), 4, 0, LIT_T, prop_cache_name));
}
inline void Sample_Address::setStreet(const d_string& Street) {
   static wchar_t prop_cache_name[] = {83, 116, 114, 101, 101, 116, 0};
   get_db()->set_property(get_ref(), 4, 0, 4,LIT_T, prop_cache_name, const_cast <d_string*>(&Street));
}

inline d_string Sample_Address::getZip() const {
   static wchar_t prop_cache_name[] = {90, 105, 112, 0};
   return d_string(get_db()->get_property(get_ref(), 5, 0, LIT_T, prop_cache_name));
}
inline void Sample_Address::setZip(const d_string& Zip) {
   static wchar_t prop_cache_name[] = {90, 105, 112, 0};
   get_db()->set_property(get_ref(), 5, 0, 5,LIT_T, prop_cache_name, const_cast <d_string*>(&Zip));
}

#endif
