#ifndef __Sample_Person
#define __Sample_Person

#include <cppbind.h>

class Sample_Address;

class Sample_Person : public Persistent_t {
   friend class d_ref<Sample_Person>;
public:

   // Constructors
protected:
   Sample_Person() {}

private:
   Sample_Person(Database* db, int oref) {
      static wchar_t cl_cache_name[] = {83, 97, 109, 112, 108, 101, 46, 80, 101, 114, 115, 111, 110, 0};
      init_openref(db, oref);
   }

public:
   virtual ~Sample_Person() {}

   // Static methods for instantiating classes
   static d_ref<Sample_Person> openref(t_istream& in, Database* db) {
      int oref; const_name_t tname;
      abs_d_ref::get_oref_n_name(in, &oref, &tname);
      return openref(db, oref, tname);
   }
   static d_ref<Sample_Person> openref(Database* db, int oref, const_name_t tname = 0) {
      if (oref == 0)
         return d_ref<Sample_Person>();
      
      Obj_t *obj; int *num_refs;
      if (db->get_proxies_info()->get_proxy_info(oref, typeid(Sample_Person), &obj, &num_refs)) {
         return d_ref<Sample_Person>(dynamic_cast<Sample_Person*>(obj), num_refs);
      } else {
         return d_ref<Sample_Person>(new Sample_Person(db, oref));
      }
   }
   static d_ref<Sample_Person> create_new(Database* db, const_str_t init_val = 0, Db_err* err = 0) {
      static wchar_t cl_cache_name[] = {83, 97, 109, 112, 108, 101, 46, 80, 101, 114, 115, 111, 110, 0};
      return openref(db, d_int(db->make_obj(cl_cache_name, init_val, err)));
   }
   static d_ref<Sample_Person> open(Database* db, const d_binary& id, int concurrency = -1, int timeout = -1, Db_err* err = 0) {
      return openref(db, d_int(db->open_obj(id, concurrency, timeout, err)));
   }
   static d_ref<Sample_Person> openid(Database* db, const const_str_t id, int concurrency = -1, int timeout = -1, Db_err* err = 0) {
      static wchar_t cl_cache_name[] = {83, 97, 109, 112, 108, 101, 46, 80, 101, 114, 115, 111, 110, 0};
      return openref(db, d_int(db->openid_obj(cl_cache_name, id, concurrency, timeout, err)));
   }


   // set/get methods

   virtual d_int getAge() const;
   virtual d_date getDOB() const;
   virtual void setDOB(const d_date&);
   virtual d_ref< d_prim_vector<d_string> > getFavoriteColors() const;
   virtual void setFavoriteColors(const d_ref< d_prim_vector<d_string> >&);
   virtual d_ref<Sample_Address> getHome() const;
   virtual void setHome(const d_ref<Sample_Address>&);
   virtual d_string getName() const;
   virtual void setName(const d_string&);
   virtual d_ref<Sample_Address> getOffice() const;
   virtual void setOffice(const d_ref<Sample_Address>&);
   virtual d_string getSSN() const;
   virtual void setSSN(const d_string&);
   virtual d_ref<Sample_Person> getSpouse() const;
   virtual void setSpouse(const d_ref<Sample_Person>&);

   // other methods

   virtual d_int Addition();
   virtual d_int Addition(const d_int& x);
   virtual d_int Addition(const d_int& x, const d_int& y);
   // x 1
   // y 1
   static d_int CurrentAge(Database *__db);
   static d_int CurrentAge(Database *__db, const d_date& date);
   // date ""
   virtual d_bool NameIDXExists(const d_string& K1);
   virtual d_int NinetyNine();
   virtual d_status OnPopulate();
   static d_int Populate(Database *__db);
   static d_int Populate(Database *__db, const d_int& count);
   static d_int Populate(Database *__db, const d_int& count, const d_int& verbose);
   static d_int Populate(Database *__db, const d_int& count, const d_int& verbose, const d_int& DeferIndices);
   static d_int Populate(Database *__db, const d_int& count, const d_int& verbose, const d_int& DeferIndices, d_int& objects);
   // count 10
   // verbose 0
   // DeferIndices 1
   // objects 0
   static d_string PopulateSerial(Database *__db);
   virtual void PrintPerson();
   static void PrintPersons(Database *__db);
   static void PrintPersonsSQL(Database *__db);
   virtual d_bool SSNKeyExists(const d_string& K1);
   static d_int StoredProcTest(Database *__db, const d_string& name, d_string& response);
   static d_int UpdateProcTest(Database *__db, const d_string& zip, const d_string& city, const d_string& state);
   static void get_ByName(d_query& query) {
      query.prepare(L"{ call Sample.SP_Sample_By_Name( ? ) }", 38);
   }

   static void get_Extent(d_query& query) {
      query.prepare(L"{ call Sample.Person_Extent(  ) }", 33);
   }

};
inline d_int Sample_Person::getAge() const {
   static wchar_t prop_cache_name[] = {65, 103, 101, 0};
   return d_int(get_db()->get_property(get_ref(), -1, 0, LIT_T, prop_cache_name));
}
inline d_date Sample_Person::getDOB() const {
   static wchar_t prop_cache_name[] = {68, 79, 66, 0};
   return d_date(get_db()->get_property(get_ref(), 3, 0, LIT_T, prop_cache_name));
}
inline void Sample_Person::setDOB(const d_date& DOB) {
   static wchar_t prop_cache_name[] = {68, 79, 66, 0};
   get_db()->set_property(get_ref(), 3, 0, 3,LIT_T, prop_cache_name, const_cast <d_date*>(&DOB));
}

inline d_string Sample_Person::getName() const {
   static wchar_t prop_cache_name[] = {78, 97, 109, 101, 0};
   return d_string(get_db()->get_property(get_ref(), 8, 0, LIT_T, prop_cache_name));
}
inline void Sample_Person::setName(const d_string& Name) {
   static wchar_t prop_cache_name[] = {78, 97, 109, 101, 0};
   get_db()->set_property(get_ref(), 8, 0, 6,LIT_T, prop_cache_name, const_cast <d_string*>(&Name));
}

inline d_string Sample_Person::getSSN() const {
   static wchar_t prop_cache_name[] = {83, 83, 78, 0};
   return d_string(get_db()->get_property(get_ref(), 11, 0, LIT_T, prop_cache_name));
}
inline void Sample_Person::setSSN(const d_string& SSN) {
   static wchar_t prop_cache_name[] = {83, 83, 78, 0};
   get_db()->set_property(get_ref(), 11, 0, 8,LIT_T, prop_cache_name, const_cast <d_string*>(&SSN));
}

#endif
