#include "../Sample_Person.h"
#include "../Sample_Address.h"

typedef d_ref<Sample_Person> d_Sample_Person;

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      std::wstring id;
      std::cout << "Enter ID of Person object to be opened:\n";
      std::wcin >> id;

      // open a Sample.Person object using %OpenId()
      d_Sample_Person person = Sample_Person::openid(&db, id.c_str());

      // Fetch some properties of this object
      std::cout << "Name " << person->getName() << '\n'
                << "City " << person->getHome()->getCity() << '\n'
                <<  '\n';

      // Modify some properties
      person->getHome()->setCity("Ulan Bator");

      // Save the object to the database
      person->save();

      // Report the new residence of this person
      std::cout << "New City: " << person->getHome()->getCity() << '\n';

      return 0;
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }

   // all objects are closed automatically
}
