#include <database.h>
#include <streams.h>

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      // create a low level stream object
      d_ref<d_char_stream> stream = d_char_stream::create_new(&db);

      // create an IOStreams extension stream object
      d_iostream io(stream);

      // put "Hello, World!" in the stream
      io << "Hello, World!";

      // rewind the stream
      io.rewind();

      std::string s;
      while (io.good())
      {
         // read the next word
         io >> s;
         // copy it to the standard output
         std::cout << s << ' ';
      }
      std::cout << '\n';

      return 0;

      // all objects are closed automatically
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }
}
