#include "../../Sample_Person.h"
#include "../../Sample_Address.h"

#include <iostream>

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      // Open an instance of the Sample.Person object
      d_ref<Sample_Person> person = Sample_Person::openid(&db, L"1");

      // set Name and SSN
      person->setName("E. Brown");
      person->setSSN("333-22-1111");
      person->setDOB(d_date(1922, 9, 22));

      // set FavoriteColors
      d_ref< d_prim_vector<d_string> > colors = person->getFavoriteColors();
      colors->clear();
      colors->push_back(d_string("Red"));
      colors->push_back(d_string("Blue"));
      colors->push_back(d_string("White"));

      // set Home
      d_ref<Sample_Address> addr = person->getHome();
      addr->setStreet("5 Washington St.");
      addr->setCity("Brighton");
      addr->setState("MA");
      addr->setZip("02135");

      // save the person
      person->save();

      std::cout << "The modified properties for Sample.Person with id 1:\n\n"
                << "Name = " << person->getName() << '\n'
                << "SSN  = " << person->getSSN() << '\n'
                << "DOB  = " << person->getDOB() << '\n';

      std::cout << "Favorite colors = "
                << (*colors)[0] << ", "
                << (*colors)[1] << ", "
                << (*colors)[2] << "\n\n";

      std::cout << "Address:\n"
                << "Street = " << addr->getStreet() << '\n'
                << "City   = " << addr->getCity() << '\n'
                << "State  = " << addr->getState() << '\n'
                << "Zip    = " << addr->getZip() << "\n\n";

      return 0;

      // all objects are closed automatically
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }
}
