#include "../../Sample_Person.h"
#include "../../Sample_Address.h"

#include <iostream>

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      // Create a new instance of Sample.Person
      d_ref<Sample_Person> person = Sample_Person::create_new(&db);

      // Set some properties
      person->setName("Test");
      person->setSSN("111-22-3333");

      // Fetch some properties
      std::cout << "Name: " << person->getName() << '\n'
                << "SSN:  " << person->getSSN() << '\n'
         // empty field
                << "DOB:  " << person->getDOB() << '\n';

      // Save instance of Person
      // person->save();

      return 0;

      // all objects are closed automatically
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }
}
