#include "../../Sample_Person.h"
#include "../../Sample_Address.h"

#include <iostream>

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      // Open an instance of the Sample.Person object
      d_ref<Sample_Person> person = Sample_Person::openid(&db, L"1");

      // Fetch some properties
      std::cout << "Name: " << person->getName() << '\n'
                << "SSN:  " << person->getSSN() << '\n'
                << "DOB:  " << person->getDOB() << '\n';

      // Attempt to bring in an embedded object
      d_ref<Sample_Address> addr = person->getHome();
      std::cout << "Street: " << addr->getStreet() << '\n'
                << "city:   " << addr->getCity() << '\n'
                << "State:  " << addr->getState() << '\n'
                << "Zip:    " << addr->getZip() << '\n';

      return 0;

      // all objects are closed automatically
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }
}
