#include "../../Sample_Person.h"
#include "../../Sample_Address.h"

#include <iostream>

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      // Open an existing instance of Sample.Person */
      d_ref<Sample_Person> person = Sample_Person::openid(&db, L"1");

      // Fetch some properties
      std::cout << "Name: " << person->getName() << '\n'
                << "SSN:  " << person->getSSN() << '\n';

      // Display existing values
      d_ref<Sample_Address> addr = person->getHome();
      std::cout << "Existing Address:" << '\n'
                << "Street: " << addr->getStreet() << '\n'
                << "city:   " << addr->getCity() << '\n'
                << "State:  " << addr->getState() << '\n'
                << "Zip:    " << addr->getZip() << '\n';

      // Modify some values
      addr->setStreet("One Memorial Drive");
      addr->setCity("Cambridge");
      addr->setState("MA");
      addr->setZip("02142");

      std::cout << "New Address:" << '\n'
                << "Street: " << addr->getStreet() << '\n'
                << "city:   " << addr->getCity() << '\n'
                << "State:  " << addr->getState() << '\n'
                << "Zip:    " << addr->getZip() << '\n';

      person->save();

      return 0;

      // all objects are closed automatically
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }
}
