#include "../../Sample_Person.h"
#include "../../Sample_Address.h"

int main()
{
   // establish the physical connection to Cache'
   Db_err conn_err;
   d_connection conn = tcp_conn::connect("localhost[1972]:Samples",
                                         "_SYSTEM", "SYS", &conn_err);
   if (conn_err)
   {
      std::cerr << conn_err << '\n';
      return -1;
   }

   try {
      // establish the logical connection to Cache'
      Database db(conn);

      // associate a query with a database
      d_query by_name(&db);

      // declare variables for row values
      d_int id;
      d_string name;
      d_date dob;
      d_string ssn;

      // prepare the query
      Sample_Person::get_ByName(by_name);

      // set parameters
      by_name.set_par(1, "O", 1);

      // execute
      by_name.execute();

      // iterate through all rows
      while (by_name.fetch())
      {
         by_name.get_data(&id);
         by_name.get_data(&name);
         by_name.get_data(&dob);
         by_name.get_data(&ssn);

         std::cout << id << ';' << name << ';' << dob << ';' << ssn << '\n';
      }

      return 0;

      // all objects are closed automatically
   }
   catch(const Db_err& err) {
      std::cerr << err << '\n';
      return -1;
   }
}
