@Echo Off

Rem CacheHung Button Windows Script Build # 031
Rem Last modification date: July 21, 2004
Rem Copyright (c) 2002, InterSystems Corporation
Rem Author		: Renato F. Aquino
Rem Title		: Technical Account Manager
Rem Department	: Customer Support

SetLocal

Rem This prevents the user from running on Windows 9x or ME
If Not "%OS%" == "Windows_NT" (
	Echo.
	Echo This script can only be executed on Windows NT, 2000 or XP
	Echo.
	Goto Abort
)

Rem Test for 4NT shell
If "%@Eval[2+2]" == "4" (
	Call :CmdOnly
	Goto Abort
)

Rem Test for Cmd.Exe shell
If "%CMDEXTVERSION%" == "" (
	Set CMDEXTVERSION=0
)
If Not %CMDEXTVERSION% GEQ 1 (
	Call :CmdOnly
	Goto Abort
)

Color 1E

If Not Exist C:\Temp\*.* (
	MkDir C:\Temp > Nul:
)

Rem %ComputerName%	already defined at OS level
Rem %UserDomain%	already defined at OS level
Rem %SystemDrive%	already defined at OS level
Rem %UserName%		already defined at OS level
Rem %OS%			already defined at OS level
Rem %WinDir%		already defined at OS level
Set CurDir=%CD%
Set WinSysDir=%SystemRoot%\System32

Set Null=

Set Find=
If Exist "%WinSysDir%\Find.Exe" (
	Set Find=%WinSysDir%\Find.Exe
)

Set NetStat=
If Exist "%WinSysDir%\NetStat.Exe" (
	Set NetStat=%WinSysDir%\NetStat.Exe
)

Set IPConfig=
If Exist "%WinSysDir%\IPConfig.Exe" (
	Set IPConfig=%WinSysDir%\IPConfig.Exe
)

For %%D in ("%WinSysDir%\Cmd.Exe") Do Set WinDrv=%%~dD

:GetCacheDir

If Not "%1" == "" (
	Set CacheInstallDir=%1
) Else (
	Echo.
	Set /p CacheInstallDir=Full name of Cache' directory: 
)

If "%CacheInstallDir%" == "" (
	Goto End
)

If Not Exist "%CacheInstallDir%\Bin\Cache.Exe" (
	Call :NotCacheDir
	Goto GetCacheDir
)
If Not Exist "%CacheInstallDir%\Cache.cpf" (
	Call :NotCacheDir
	Goto GetCacheDir
)
If Not Exist "%CacheInstallDir%\Mgr\Cache.Dat" (
	Call :NotCacheDir
	Goto GetCacheDir
)

Echo.
Echo Please wait...

Set CacheConfigFile="%CacheInstallDir%\Cache.cpf"

Set CacheMgrDir=%CacheInstallDir%\Mgr
Set CacheBinDir=%CacheInstallDir%\Bin

Set FullMachineName=Unknown
If Not "%Find%" == "" (
	For /f "Tokens=2" %%a in ('Ping -a %ComputerName% ^| %Find% "Pinging"') Do Set FullMachineName=%%a
)

Set IPAddress=Unknown
If Not "%Find%" == "" (
	For /f "Delims=[] Tokens=2" %%a in ('Ping -a %ComputerName% ^| %Find% "Pinging"') Do Set IPAddress=%%a
)

Set LogFile="%CacheMgrDir%\CacheHungButton.html"

Rem Generate HTML header

Echo ^<html^> > %LogFile%
Echo ^<head^> >> %LogFile%
Echo ^<title^> >> %LogFile%
Echo Cach Diagnostic Log. Filename: CacheHungButton.html  >> %LogFile%
Echo ^</title^> >> %LogFile%
Echo ^<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"^> >> %LogFile%
Echo ^</head^> >> %LogFile%
Echo ^<body bgcolor="#FFFFFF" text="#000000"^> >> %LogFile%
Echo ^<table align="center" width="98%%" border="1" bordercolor="#999999" bgcolor="#CCCCCC"^> >> %LogFile%
  Echo ^<tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"^> >> %LogFile%
    Echo ^<td colspan="5" height="40" align="center" ^> >> %LogFile%
      Echo ^<font face="Arial, Helvetica, sans-serif" size="5" color="#0000FF"^>^<b^>Cach Diagnostic Log^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
  Echo ^</tr^> >> %LogFile%
  Echo ^<tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#general"^>General^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#keyfile"^>Key File^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#cpf"^>CPF File^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#cconsole"^>cconsole.log^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#netstat"^>Network Status^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
  Echo ^</tr^> >> %LogFile%
  Echo ^<tr bgcolor="#FFFFFF" bordercolor="#CCCCCC"^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#osproc1"^>OS Processes # 1^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#cstat1"^>cstat # 1^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#osproc2"^>OS Processes # 2^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^<b^>^<a href="#cstat2"^>cstat # 2^</a^>^</b^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
    Echo ^<td align="center"^> >> %LogFile%
      Echo ^<font size="2" face="Arial, Helvetica, sans-serif" color="#0000FF"^>^</font^> >> %LogFile%
    Echo ^</td^> >> %LogFile%
  Echo ^</tr^> >> %LogFile%
Echo ^</table^> >> %LogFile%

Echo ^<p^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>Configuration^</font^>^</b^> >> %LogFile%
Echo ^</p^> >> %LogFile%

Echo ^<pre^> >> %LogFile%
Echo Evidence Information for Cach configuration in directory: %CacheInstallDir% on Machine "%ComputerName%" >> %LogFile%
Echo ^</pre^> >> %LogFile%

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="general"^>^</a^>General^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%

Echo Host Name: %FullMachineName%   Domain Name: %UserDomain%   IP Address: %IPAddress% >> %LogFile%
Echo. >> %LogFile%
Echo Log created by User "%UserName%" on %Date% at %Time% >> %LogFile%
Echo. >> %LogFile%
Echo Operating System Information: >> %LogFile%
Echo. >> %LogFile%
If Exist "%CacheBinDir%\PsInfo.exe" (
	For /f "Tokens=*" %%a in ('"%CacheBinDir%\PsInfo.exe" -h -s -d') Do @Echo %%a >> %LogFile%
) Else (
	For /f "Tokens=*" %%a in ('Ver') Do @Echo %%a >> %LogFile%
)
If Exist "%WinDrv%\Program Files\Common Files\Microsoft Shared\MSInfo\msinfo32.exe" (
	Echo. >> %LogFile%
	Pushd C:\Temp
	"%WinDrv%\Program Files\Common Files\Microsoft Shared\MSInfo\msinfo32.exe" /Report MSInfo.$$$ /Categories +SystemSummary
	If Exist MSInfo.$$$ (
		Type MSInfo.$$$ >> %LogFile%
		Del MSInfo.$$$ > Nul:
	)
	Popd
)
Echo. >> %LogFile%
Echo Windows Directory: %WinDir%   Windows System Directory: %WinSysDir% >> %LogFile%
Echo. >> %LogFile%
Echo Cach Version String: >> %LogFile%
If Not "%Find%" == "" (
	For /f "Skip=2 Tokens=*" %%a in ('%Find% "Cache for Windows" "%CacheBinDir%\Cache.Exe"') Do Set CacheVerString=%%a
) Else (
	Set CacheVerString=*** Unknown Cach Version ***
)
Echo %CacheVerString% >> %LogFile%
Echo. >> %LogFile%
Echo Current Drive and Directory: %CurDir% >> %LogFile%
Rem Memory command available in 4NT only
Rem Echo. >> %LogFile%
Rem Echo Memory usage: >> %LogFile%
Rem Memory >> %LogFile%
Echo. >> %LogFile%
CHCP >> %LogFile%
Echo ^</pre^> >> %LogFile%

For /f "Tokens=6" %%a in ("%CacheVerString%") Do Set CacheVerNumber=%%a

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="keyfile"^>^</a^>Key File^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
Echo Cach Key File %CacheMgrDir%\Cache.Key: >> %LogFile%
Echo. >> %LogFile%
Type "%CacheMgrDir%\Cache.Key" >> %LogFile%
Echo ^</pre^> >> %LogFile%

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="cpf"^>^</a^>CPF File^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
Echo Cach Configuration File %CacheConfigFile%: >> %LogFile%
Echo. >> %LogFile%
Type %CacheConfigFile% >> %LogFile%
Echo ^</pre^> >> %LogFile%

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="cconsole"^>^</a^>cconsole.log^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
Echo Cach %CacheMgrDir%\cconsole.log >> %LogFile%
Type "%CacheMgrDir%\cconsole.log" >> %LogFile%
Echo ^</pre^> >> %LogFile%

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="netstat"^>^</a^>Network Status^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%

If Not "%IPConfig%" == "" (
	Echo Output of IPConfig.Exe /All >> %LogFile%
	Rem Echo. >> %LogFile%
	Cmd.Exe /a /c %IPConfig% /All >> %LogFile%
	Echo. >> %LogFile%
) Else (
	Echo IPConfig information cannot be displayed, program IPConfig.exe was not found in %WinSysDir% >> %LogFile%
)

If Not "%NetStat%" == "" (
	Echo Output of NetStat.Exe -an >> %LogFile%
	Rem Echo. >> %LogFile%
	%NetStat% -an >> %LogFile%
	Echo. >> %LogFile%
	Echo Output of NetStat.Exe -s >> %LogFile%
	Rem Echo. >> %LogFile%
	%NetStat% -s >> %LogFile%
) Else (
	Echo NetStat information cannot be displayed, program NetStat.exe was not found in %WinSysDir% >> %LogFile%
)
Echo ^</pre^> >> %LogFile%

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="osproc1"^>^</a^>OS Process List # 1^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
If Exist "%CacheBinDir%\PsList.exe" (
	Echo PsList.Exe -t -- Show Process Tree >> %LogFile%
	"%CacheBinDir%\PsList.exe" -t >> %LogFile%
	Echo. >> %LogFile%
	Echo PsList.Exe -- Show Processes >> %LogFile%
	"%CacheBinDir%\PsList.exe" >> %LogFile%
	Echo. >> %LogFile%
	Echo PsList.Exe -x -- Show Processes, Memory Information and Threads >> %LogFile%
	"%CacheBinDir%\PsList.exe" -x >> %LogFile%
) Else (
	Echo Process Information cannot be displayed, program PsList.Exe was not found >> %LogFile%
)
Echo ^</pre^> >> %LogFile%

Set cstatswitches=-e2 -m-1 -n1 -L1 -u1 -v1 -p-1 -c-1 -q1 -w2 -E-1

If %CacheVerNumber% GTR 5 (
	Set cstatswitches=-e2 -m-1 -n3 -j5 -L1 -u-1 -v1 -p-1 -c-1 -q1 -w2 -S-1 -E-1 -N65535
) Else (
	Set cstatswitches=-e2 -m-1 -n1 -L1 -u1 -v1 -p-1 -c-1 -q1 -w2 -S-1 -E-1
)

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="cstat1"^>^</a^>cstat Snapshot # 1^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
Echo Cach cstat. Active switches: %cstatswitches% >> %LogFile%
Echo. >> %LogFile%
"%CacheBinDir%\cstat.Exe" %cstatswitches% -s"%CacheMgrDir%" >> %LogFile%
Echo ^</pre^> >> %LogFile%

Rem The For command below should cause almost the same effect as a Sleep 10
For /l %%I in (1,1,100000) Do Echo. > Nul:

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="osproc2"^>^</a^>OS Process List # 2^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
If Exist "%CacheBinDir%\PsList.exe" (
	Echo PsList.Exe -t -- Show Process Tree >> %LogFile%
	"%CacheBinDir%\PsList.exe" -t >> %LogFile%
	Echo. >> %LogFile%
	Echo PsList.Exe -- Show Processes >> %LogFile%
	"%CacheBinDir%\PsList.exe" >> %LogFile%
	Echo. >> %LogFile%
	Echo PsList.Exe -x -- Show Processes, Memory Information and Threads >> %LogFile%
	"%CacheBinDir%\PsList.exe" -x >> %LogFile%
) Else (
	Echo Process Information cannot be displayed, program PsList.Exe was not found >> %LogFile%
)

Echo ^</pre^> >> %LogFile%

Echo ^<hr noshade size="4"^> >> %LogFile%
Echo ^<br^> >> %LogFile%
Echo ^<b^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<a name="cstat2"^>^</a^>cstat Snapshot # 2^</font^>^</b^> >> %LogFile%
Echo ^<pre^> >> %LogFile%
Echo Cach cstat. Active switches: %cstatswitches% >> %LogFile%
Echo. >> %LogFile%
"%CacheBinDir%\cstat.Exe" %cstatswitches% -s"%CacheMgrDir%" >> %LogFile%
Echo ^</pre^> >> %LogFile%

Echo ^<hr size="4" noshade^> >> %LogFile%
Echo ^<p^>^<font face="Arial, Helvetica, sans-serif" size="4" color="#0000FF"^>^<b^>End of Cach Diagnostic Log^</b^>^</font^> >> %LogFile%
Echo ^</p^> >> %LogFile%

Echo ^<p^> >> %LogFile%
Echo End of Evidence Information for Cach configuration in directory: %CacheInstallDir% on Machine "%ComputerName%" >> %LogFile%
Echo ^</p^> >> %LogFile%

Echo ^</body^> >> %LogFile%
Echo ^</html^> >> %LogFile%

Echo.
Echo Log file saved to:
Echo %LogFile%
For %%F in (%LogFile%) Do @Echo File size is %%~zF bytes long

Goto End

:CmdOnly

Echo.
Echo You must run this script from the Windows 2000 Command Interpreter Cmd.Exe
Echo with the Command Extensions option enabled.
Echo.
Goto :EOF

:NotCacheDir

Echo.
Echo Directory %CacheInstallDir% doesn't seem to be a Cache' 3.2.x, 4.x or 5.x directory
Echo.
Echo Please enter the full specification of the directory where Cache' was
Echo installed, including the Drive letter (C:, D:, etc.) and the full path,
Echo e.g. C:\CacheSys
Goto :EOF

:End

EndLocal

:Abort

Goto :EOF
